/* jgodir.c             Wed 12-15-1993
Wed 12-15-1993  creation, from ovdir.c.
*/

#include "jgodir.h"

/****************************************************************************
****************************************************************************/
_v char cwd[MaxPath];
_v char truecwd[MaxPath];
_v char drive[MAXDRIVE];
_v char dir[MAXDIR];
_v char file[MAXFILE];
_v char ext[MAXEXT];
_v char newmask[MaxPATH];

_v int dircount, nfiles;
_v long bytesize;

_v char *nothing="";

_v int showcount;

_v WORD hycount;

_v int true=NO;
_v int subs, nobaredrive;
_v int dotstyle, bare;
_v int includedirs=YES;
#if ONLY_DIR
_v int onlydirs;
#endif
_v int wide;
_v char *baretrail="";

#if PREFIX
_v char *prefix="";
#endif

#if QUOTES
_v int quotes;
#endif

_v char *origwd;

_v FILE *errout=stdout;

_v int thedriveletter=0;  /* i.e. for calls what need the drive, this is it. */

_v int military;

#if EXTOP
_v int noextension;
#endif

#if BAREWIDE
_v int boption;
#endif

int attract, attributes;
enum {
  ATTOR=1,
  ATTAND
};

_v char *effchars;



/****************************************************************************
****************************************************************************/
_f void lowern(char *p, int max) {
  while (max-- && (*p=tolower(*p))) ++p;
}

_f char *strichr(const char *s, int c) {
  int i, lc, uc;
  lc = tolower(c);
  if ((uc = toupper(c))==lc)
  return strchr(s,c);

  for (i=0; s[i]; ++i) {
    if (
    (s[i]==lc) ||
    (s[i]==uc)
    )
    return s+i;
  }
  return NULL;
}


/****************************************************************************
lessee: int 21h function 69h:          page 743 Undoc Dos, 2nd edition.
                         440D, CX=0866 page 692 ditto
acherly turns-out neither of these acherly works; the old DOS guy does. Sigh.
****************************************************************************/
/* this one for DOS 3 or less. */
_f char *volname(void) {
  static char mask[]="c:*.*";
  static char name[15];
  char *p;
  struct ffblk ffblk;
  mask[0]=thedriveletter;
  name[0]='\0';
  if (!findfirstdos(mask,&ffblk,FA_LABEL)) {
    strcpy(name,ffblk.ff_name);
/*   01234567890
says GATEFORK.ED
*/
    if ( (p=strchr(name,'.')) && ((p-name)==8) ) {
      while (p[0]=p[1])
      ++p;
    }
  }
  return name;
}

char *parenname(void) {
  static char name[35];
  char *p;

  if (*(p=volname())) {
    sprintf(name,"(%s) ",p);
    lowern(name,999);
    return name;
  }

  return nothing;
}


/****************************************************************************
****************************************************************************/
/* dst must be 128 bytes or more (undoc dos p. 565.) */
_f void truename(char *dst, char *source) {
  union REGS regs;
  struct SREGS segs;
#if !__COMPACT__
/*   #error Didn't test in anything but compact. */
#endif
  segs.ds  =FP_SEG(source);
  regs.x.si=FP_OFF(source);
  segs.es  =FP_SEG(dst);
  regs.x.di=FP_OFF(dst);
  regs.h.ah=0x60;
  intdosx(&regs,&regs,&segs);
}

/*************************************************************************
So
012345678
\\d.\a.\
d:\

  if (directory begins with \\) {
    driveletter is directory[2]
    pickup drivel starting at 7.
  }

I mean, why not? // Well according to these stupid books, the form may change.
The "illegal" form is .\; normally the dot only appears if there *is* an
extension. And then on the other hand, apparently lunatics will have names
like PHANTOM H:\ so it's all pretty hopeless.... // Nah it's fine. See the
only reason I getting all fussed-up was because I thought I needed the drive
letter to get the label. But of course I can get the *current drive* when I
start-up, or the user's specification when I *set* the drive, and do it
without tears. So all this pain and suffering was totally unnecessary.
*************************************************************************/
_f void trueername(char *dst, char *source) {
  OVtruename(dst,source);
  if (!strncmp(dst,"\\\\",2)) {
    char *last, *next;
    int count=127;
    dst[0]=dst[2];
    dst[1]=':';
    dst[2]='\\';

    last=dst+3;
    while(next=strstr(last,".\\"))
    last=next+2;

    count -= last-(dst);

    strncpy(dst+3,last,count);
    dst[127]='\0';
  }
}

_f char *lastchar(char *s) {
  if (!*s) return s;
  return s+strlen(s)-1;
}

/* if terminated with \\, deletes that, returns YES. else NO. */
_f int slashed(char *s) {
  char *p;
  if (*(p=lastchar(s))=='\\') {
    if (strcmp(s+1,":\\") && strcmp(s,"\\") )
    *p='\0';
    return YES;
  }
  return NO;
}

_f char *stristr(char *target, char *what) {
  int length;
  if (length=strlen(what)) {
    while (*target) {
      if (!(strnicmp(target,what,length))) return target;
      ++target;
    }
  }
  return NULL;
}



/****************************************************************************
****************************************************************************/
_v int isCc=NO;      /* YES when ^C. */

int origctlbk=0;

void interrupt(*old1bh)();
void interrupt(*old23h)();

void interrupt new1bh() {
  isCc=YES;
}

void interrupt new23h() {
  isCc=YES;
}

_f void installbreak(void) {
  origctlbk=getcbrk();
  setcbrk(0);
  old1bh=getvect(0x1b);
  old23h=getvect(0x23);
  setvect(0x23,new23h);
  setvect(0x1b,new1bh);
}

_f void removebreak(void) {
  setvect(0x1b,old1bh);
  setvect(0x23,old23h);
  setcbrk(origctlbk);
}


/****************************************************************************
****************************************************************************/
/****************************************************************************
Shoudl be like

  Defines:
    FA_RDONLY     Read-only attribute
    FA_HIDDEN     Hidden file
    FA_SYSTEM     System file
    FA_LABEL      Volume label
    FA_DIREC      Directory
    FA_ARCH       Archive

  Defined in dos.h


 junk          3-17-92  4:44p (directory)
 old           5-18-93 10:26a (directory)
 swap          2-16-93  1:11p (directory)
 business     10-08-92  7:04p      16,178
 edir         11-17-93  7:58p       6,067
 log          10-13-93  4:03p      56,686
 readme        3-02-93 10:47a       1,539
 bingo    aaa  4-27-92  9:57a           8
 shasm    asm 10-08-92  4:24p       2,448
 swap     asm  2-16-93  1:35p      86,628
 jgodir   bak 12-15-93  9:52a       4,039 a
 abatch   bat 10-22-92  4:16p         231
 all      bat 12-03-93 12:51p       4,135 a
 altc     bat 10-13-93  8:37p         106
 altm     bat  9-27-93 12:38p          90
****************************************************************************/

_v DIRENTRY *files;
_v long maxfiles;



/****************************************************************************
****************************************************************************/
_f char *showatts(int atts) {
/*
FA_RDONLY     Read-only attribute *
FA_HIDDEN     Hidden file         *
FA_SYSTEM     System file
FA_LABEL      Volume label
FA_DIREC      Directory
FA_ARCH       Archive             *
*/
  static char someatts[]="WXYZ";
  strcpy(someatts,"    ");
  if (atts & FA_ARCH) someatts[0]='a';
  if (atts & FA_RDONLY) someatts[1]='r';
  if (atts & FA_HIDDEN) someatts[2]='h';
  if (atts & FA_SYSTEM) someatts[3]='s';
  return someatts;
}

/* returns 0 for a, etc. */
_f int retdrive(char *path) {
  int c;
  if ( (path[1]==':') &&
  ( ((c=toupper(*path)) >='A') ||
  (c <= 'M'))) return c-'A';
  return getdisk();
}


/* where driven is 0 .. for A... */
_f long room(int driven) {
  struct dfree dtable;
  getdfree(driven+1,&dtable);
  if (dtable.df_sclus == 0xffff) return 0;
  return
  (long)dtable.df_avail *
  (long)dtable.df_sclus *
  (long)dtable.df_bsec
  ;
}

_f long droom(char *path) {
  return room(retdrive(path));
}

_f int showmark(int filestat) {
  if (filestat & dstatDONE) return '*';
  if (filestat & dstatMARKED) return '+';
  return ' ';
}

_f char *commad(long value, int max) {
  LOCALK { NSIZE=25 };
  static char dst[NSIZE];
  char anumber[NSIZE];
  char *s=anumber, *d=dst;
  int comma
#if GIGAK
  , k=NO
#endif
  ;


#if GIGAK
  if ((BIG)value >= 1000000000) {
    (BIG)value /= 1000;
    k=YES;
  }
#endif

  sprintf(anumber,"%ld",value);
  comma=strlen(anumber);
  while(1) {
    *d++=*s++;
    if (!*s) break;
    if (! (--comma % 3)) {
      *d++ = ',';
      comma=3;
    }
  }
  *d='\0';

#if GIGAK
  if (k) {
    *d++='k';
    *d='\0';
  }
#endif

  if (strlen(dst) > max) {
    strcpy(dst+max-2,"..");
  }
  return dst;
}

_f char *showtime(FFTIME *time) {
  int hour, ampm;
  static char atime[]="00:00a";

  if (!time->time) {
    strcpy(atime,     "      ");
    return atime;
  }

  hour = time->bits.hours;

  if (military) {
    ampm=' ';
  }
  else {
    if (hour >= 12)
    ampm='p';
    else
    ampm='a';
    if (hour >12)
    hour -= 12;
  }
  sprintf(atime,"%2d:%02d%c",
  hour,time->bits.minutes,ampm);
  return atime;
}

/* like chdir, except works (does drive too); returns -1 if badness. */
_f int setpath(char *path) {
  int drive;
  if (!*path)
  return NO;        /* do nothing */
  if (path[0] && (path[1]==':') ) { /* do drive spec please! */
    drive= (AD1(path[0])) -1;   /* a|A.. ==> 0.. */
    setdisk(drive);
    if (getdisk() != drive) return -1;
    if (!path[2]) return 0;      /* JUST a drive spec. */
  }
  return OVchdir(path);
}

/* #define chdir setpath /* I just changed them please. */


/****************************************************************************
****************************************************************************/
/******************************************************************/
fixdirsort(const DIRENTRY *one, const DIRENTRY *two) {
  return ((two)->stat & dstatDIR) - ((one)->stat & dstatDIR);
}

int fSortByName(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two)) return result;
  if (!(result=strncmp((one)->name,(two)->name,Nsize)))
  return strncmp((one)->ext,(two)->ext,Xsize);
  return result;
}

int fSortByExt(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two)) return result;
  if (!(result=strncmp((one)->ext,(two)->ext,Xsize)))
  return strncmp((one)->name,(two)->name,Nsize);
  return result;
}

int fSortBySize(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two)) return result;
  if ((one)->size == (two)->size)
  return fSortByName(one,two);
  if ((one)->size < (two)->size) return -1;
  return 1;
}

int fSortByDate(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two)) return result;
  if (!(result=((one)->date - (two)->date)) &&
  !(result=((one)->time - (two)->time))
  )
  return fSortByName(one,two);
  return result;
}


whosort(int sortstyle, int nfiles) {
/*  int(*fcmp)(const void *, const void *); */
  int(*fcmp)();
  switch(sortstyle) {
    case SortByName:  fcmp=fSortByName; break;
    case SortByExt:   fcmp=fSortByExt; break;
    case SortBySize:  fcmp=fSortBySize; break;
    case SortByDate:  fcmp=fSortByDate; break;
    default:
    return;
  }
  qsort(files,nfiles,sizeof(DIRENTRY),fcmp);
}

/****************************************************************************
****************************************************************************/
_v int headed;
_v int diranyway=YES;
_v int trailer_anyway;
_v int bytes_left;

_f void dirintro(int behavior, FILE *where) {
  static int bump, hyphens;
  switch (behavior) {
    case LOGCLEAR:
    headed=bump=hyphens=NO;
    break;

    case LOGBUMP:         bump=YES;                 break;
    case LOGHYPHENS:      hyphens=YES;              break;

    case HEADITANYWAY:
    if (!diranyway)
    return;

    case HEADIT:
    if (headed)
    return;

    headed=YES;

    if (bump)
    showbump(where);


    if (hycount && hyphens &&
#if BAREWIDE
    (!boption)
#else
    ((!bare) || wide )
#endif
    )
    {
      fprintf(where,
      "--------------------------------------------------------\n");
    }
    hycount=YES;

    if
#if BAREWIDE
    (!boption)
#else
    (!bare || wide)
#endif

    fprintf(where,
    "directory of %s%s\n",parenname(),cwd);

    bump=hyphens=NO;
    break;
  }
}

_f void dirtrailer(FILE *where) {
#if BAREWIDE
  if (boption && (!trailer_anyway))
  return;
#endif

  if (diranyway)
  dirintro(HEADIT,where);
  if (headed) {
    if (wide)
    showbump(where);
    else        /* wide always does summary. */
    if (bare && (!trailer_anyway))
    return;

    /* do the summary. */

    fprintf(where,
    "%u files, ",
    nfiles-dircount);

    if (includedirs)
    fprintf(where,
    "%u directories, ",
    dircount);

    fprintf(where,
    "%s bytes",
    commad(bytesize,15)
    );

/****************************************************************************
Thu 4/24/2008 1:54 pm. So just stop printing the bytes left, unless -z,
because it's almost always wrong.
****************************************************************************/
    if (bytes_left)
    fprintf(where,
    ", %s bytes free  ",
    commad(droom(cwd),15)
    );

    showcount=1;        /* fake \n request. */
  }
}


/******************************************************************/

/*****************************************************************
12345678.BOI 10,123,123 03-09-92 12:20a ARH
12345678.BOI 03-09-92 12:20a ARH 10,123,123 <-- ?
*/

int goodatterbutes(int atts) {
  if (attributes) {
    switch (attract) {
/*    case 0: */
      default: return YES;

      case ATTOR:
      if (atts & attributes)
      return YES;
      break;

      case ATTAND:
      if ((atts & attributes) == attributes)
      return YES;
      break;
    }
    return NO;
  }
  return YES;
}

#if EXTOP
_f DIRENTRY *extensionoid(DIRENTRY *file) {
  static DIRENTRY phony;
  char *p;

  if (!noextension)
  return file;

  phony = *file;
  phony.ext[0]='\0';
#if LFNS
  phony.lext = "";
  if (p=strrchr(phony.lname,'.'))
  *p = '\0';
#endif

  return &phony;

}
#endif

/****************************************************************************
****************************************************************************/

/****************************************************************************
****************************************************************************/
_f void showafilep(FILE *where, DIRENTRY *file) {
  int t;
  char *left=nothing, *right=nothing;

  if (isCc)
  exeunt(19);

#if EXTOP
  file = extensionoid(file);
#endif

#if !ExcludeINSHOFILES
  if (!goodatterbutes(file->atts))
  return;
#endif

  if (file->stat & dstatDIR) {
#if !ExcludeINSHOFILES
    if (!includedirs)
    return;
#endif

#if ONLY_DIRS
    if (!onlydirs) {
      left="[";
      right="]";
    }
#else
    left="[";
    right="]";
#endif
  }
  if (bare) {
    if (true) {
      char *dp, d[MaxPath], s[MaxPath];
      sprintf(s,"%.8s%s%.3s",
      file->name,
      (*file->ext ? "." : nothing),
      file->ext);
      trueername(d,s);

      lowern(d,9999);
      if (nobaredrive && d[0] && (d[1]==':'))
      dp=d+2;
      else
      dp=d;

      fprintf(where,
#if PREFIX
      "%s"
#endif
      "%s%s%s%s\n",

#if PREFIX
      prefix,
#endif
      left,
      dp,
      right,
      baretrail);
      return;
    }

    showcount += (t=fprintf(where,
#if PREFIX
    "%s"
#endif
    "%s%.8s%s%.3s%s%s",
#if PREFIX
      prefix,
#endif
    left,
    file->name,
    (*file->ext ? "." : nothing),
    file->ext,
    right,
    baretrail));
    if (wide) {
      if (showcount>=WIDELINE) {
        fputc('\n',where);
        showcount=0;
      }
      else {
        while(t<WIDEFIELD) {
          fputc(' ',where);
          ++showcount;
          ++t;
        }
      }
    }
    else
    fputc('\n',where);

    return;
  }
  if (dotstyle && *file->ext) {
    t=fprintf(where,
    "%c%.8s.%.3s ",
    showmark(file->stat),
    file->name,
    file->ext);
    if (t>0) {
      while(t++<14)
      putchar(' ');
    }

    fprintf(where,
    "%2u-%02u-%02u %s ",
    MONTH(file->date),
    DATE(file->date),
    YEAR(file->date),
    showtime((FFTIME*) &file->time)
    );
  }
  else {
    fprintf(where,
    "%c%-8.8s %-3.3s %2u-%02u-%02u %s ",
    showmark(file->stat),
    file->name,
    file->ext,
    MONTH(file->date),
    DATE(file->date),
    YEAR(file->date),
    showtime((FFTIME*) &file->time)
    );
  }

#if SHOWDIRATTS
  if (file->stat & dstatDIR)
  fprintf(where,"(directory) %s",
  showatts(file->atts));
#else
  if (file->stat & dstatDIR)
  fprintf(where,"(directory)");
#endif
  else
#if YES /* COMMADFILES */
  fprintf(where,
  "%11.s %s",
  commad(file->size,11),
  showatts(file->atts)
  );
#else
  fprintf(where,
  "%s %ld",
  showatts(file->atts),
  file->size);
#endif
  fprintf(where,"\n");
}

_f void showbump(FILE *where) {
  if ( /* wide && */ showcount)
  fputc('\n',where);
  showcount=0;
}

_f void makeafile(DIRENTRY *file, struct ffblk *ffblk, int sum) {
  int t;
  char *p;
  strncpy(file->name,ffblk->ff_name,Nsize);
  if (p=strchr(ffblk->ff_name,'.')) {
    if ( (t=p-ffblk->ff_name) <Nsize) file->name[t]='\0';
    strncpy(file->ext,p+1,Xsize);
  }
  else file->ext[0]='\0';
  lowern(file->name,Nsize);
  lowern(file->ext,Xsize);
  file->atts=ffblk->ff_attrib;
  file->size=ffblk->ff_fsize;
  file->date=ffblk->ff_fdate;
  file->time=ffblk->ff_ftime;
  if (ffblk->ff_attrib & FA_DIREC) {
    file->stat = dstatDIR;
    if (sum)
    ++dircount;
  }
  else {
    file->stat = 0;
    if (sum)
    bytesize += file->size;
  }
}



/* returns the actual # of files. Allocates 'dem directory entries? If can't
fit, returns -1. // nah make it just fiddle-in an extra guy there. // You
can't dump this list in between launchings, 'cause then all the little tags
disappear, which'd be awful.... (These comments from another program) */

_f void showfiles(FILE *where, char *mask, int sortstyle) {
  DIRENTRY adir;
  struct ffblk ffblk;
  int idx=0, result, eff;

  if (isCc)
  exeunt(19);

  dircount=nfiles=0;
  bytesize=0;

  if (!(fnsplit(mask,drive,dir,file,ext) & (FILENAME|EXTENSION))) {
    fnmerge(newmask,drive,dir,"*",".*");
    mask=newmask;
  }

  trueername(cwd,mask);
  result=fnsplit(cwd,drive,dir,NULL,NULL);
  fnmerge(cwd,drive,dir,NULL,NULL);

  lowern(cwd,MaxPath);

#if 0
  if (! (result & (FILENAME|EXTENSION))) {
    fnmerge(newmask,drive,dir,"*",".*");
    mask=newmask;
  }
#endif

  bytesize=0;
  result=findfirstdos(mask,&ffblk,GETSTAT);
  dircount=0;
  while(!result) {

    if (isCc)
    exeunt(19);

#if ONLY_DIR
    if (
    (onlydirs) &&
    (!(ffblk.ff_attrib & FA_DIREC))
    )
    goto TRYAGAIN;
#endif

#if ExcludeINSHOFILES
    if (
    (!goodatterbutes(ffblk.ff_attrib)) ||
    ( (ffblk.ff_attrib & FA_DIREC) && (!includedirs) )
    )
    goto TRYAGAIN;
#endif

    if (!(*ffblk.ff_name=='.')) {               /* skip dumb stuff. */

      if (effchars)
      for (eff=0; effchars[eff]; ++eff) {
        if (strichr(ffblk.ff_name,effchars[eff]))
        goto TRYAGAIN;
      }

      dirintro(HEADIT,where);

      if (!sortstyle) {
        makeafile(&adir,&ffblk,YES);
        showafilep(where,&adir);
      }
      else {
        makeafile(files+nfiles,&ffblk,YES);
      }
      if (sortstyle && (++nfiles > maxfiles)) {
        /* abort to unsorted. */
        for (idx=0; idx<nfiles; ++idx) {
          showafilep(where,files+idx);
        }
        sortstyle=sortNOT;
      }
    }

    TRYAGAIN:
    result=findnextdos(&ffblk);
  }

  if (sortstyle) {
    whosort(sortstyle,nfiles);
    for (idx=0; idx<nfiles; ++idx) {
      showafilep(where,files+idx);
    }
  }

  dirtrailer(where);

}


/****************************************************************************
****************************************************************************/

_f char *finddir(struct ffblk *ffblk, int first) {
  if (first) {
    if (findfirstdos("*.*",ffblk,FA_DIREC)) return NULL;
  }
  else {
    if (findnextdos(ffblk)) return NULL;
  }
  while ( ! ((ffblk->ff_attrib) & FA_DIREC) ||
  strcmp(ffblk->ff_name,".")==0 ||
  strcmp(ffblk->ff_name,"..")==0) {
    if (findnextdos(ffblk)) return NULL;
  }
  return ffblk->ff_name;
}

_f void directories(FILE *where, char *mask, int sortstyle) {
  char *thisdir, *newdir;
  struct ffblk ffblk;

  if (isCc)
  exeunt(19);

  dirintro(LOGCLEAR,NULL);
  dirintro(LOGBUMP,NULL);
  dirintro(LOGHYPHENS,NULL);

  OVshowfiles(where,mask,sortstyle);

  thisdir=OVgetcwd(NULL,MaxPath);

  if (newdir=finddir(&ffblk,YES)) {
    do {
      if (setpath(newdir)) {
        fprintf(errout,"chdir failed. %s defective?\n",newdir);
        /* exeunt(37); */ /* No no keep going. */
      }
      else
      OVdirectories(where,mask,sortstyle);
      setpath(thisdir);
    }
    while(newdir=finddir(&ffblk,NO));
  }
  free(thisdir);
}


/****************************************************************************
****************************************************************************/
#if LFNS
  #define COMPILE " (TC 2.0 w95)"
#else
  #define COMPILE ""
#endif

#ifdef __FLAT__
  #undef COMPILE
  #define COMPILE " (win32)"
#endif

/****************************************************************************

jgodir [mask] [options] Copyright (c) j.g. owen 1994-2001 (`" __DATE__ `")
i.e., jgodir *.*, or just jgodir.`" COMPILE `" sort by /n name, /s size, /e
extension (default), /d date & time, /u unsorted. /a show directories
(default); /a- don't (default for /b /B /c //). /aa only /. Name.dot style. //
show contents of subdirectories. /w wide. /b[trail] unadorned style, lines
ended with optional trail. /t 24 hour time. /B[trail] == b, + true name.
/c[trail] == B, + no drive. -p[prefix] /:a show only files with arc attribute.
arhs permitted; ORs; unless "/:&ar". Attributes in adorned display: a:archive;
r:read-only; h:hidden; s:system. Trailing "\" taken as directory; else file.
(Rename to *dos*.exe to defeat W95 processing.) /x no extensions. /q quote
bare names. /y summary anyway (bytes) /z show bytes left /f~x exclude names
with ~, x.

****************************************************************************/

_f void exeunt(int code) {
  setpath(origwd);
  removebreak();
  exit(code);
}

depart() {
  fprintf(errout,





"jgodir [mask] [options] Copyright (c) j.g. owen 1994-2001 (" __DATE__ ")\n"
"i.e., jgodir *.*, or just jgodir." COMPILE " sort by /n name, /s size, /e\n"
"extension (default), /d date & time, /u unsorted. /a show directories\n"
"(default); /a- don't (default for /b /B /c //). /aa only /. Name.dot style. //\n"
"show contents of subdirectories. /w wide. /b[trail] unadorned style, lines\n"
"ended with optional trail. /t 24 hour time. /B[trail] == b, + true name.\n"
"/c[trail] == B, + no drive. -p[prefix] /:a show only files with arc attribute.\n"
"arhs permitted; ORs; unless \"/:&ar\". Attributes in adorned display: a:archive;\n"
"r:read-only; h:hidden; s:system. Trailing \"\\\" taken as directory; else file.\n"
"(Rename to *dos*.exe to defeat W95 processing.) /x no extensions. /q quote\n"
"bare names. /y summary anyway (bytes) /z show bytes left /f~x exclude names\n"
"with ~, x.\n"





  );
  exeunt(1);
}


_f int setdrive(char **mask) {
  int result, c;
  if (**mask && ((*mask)[1]==':')) {
    thedriveletter=**mask;
    c=(*mask)[2];
    (*mask)[2]='\0';
    result=setpath(*mask);
    (*mask)[2]=c;
    *mask += 2;             /* make it path, not drive. */
    return result;
  }
  return 0;
}

#if ONEDIR
_f int itsonedir(char *mask) {
  struct ffblk ffblk;

  if (
  (!(findfirstdos(mask,&ffblk,0))) ||

  (fnsplit(mask,NULL,NULL,NULL,NULL) & WILDCARDS))
  return NO;

  return
  !findfirstdos(mask,&ffblk,FA_DIREC);

}

_f int strplus(char *dst, char *src, int max) {
  int index;
  --max;
  index=strlen(dst);
  while(*src && (index < max))
  dst[(index)++]=*src++;
  dst[index]='\0';
  return index;
}

char *slash(char *mask) {
  static char slashpath[MaxPATH+4];
  int i;
  if ( (i=strlen(mask)) && (mask[i-1]!='\\')) {
    strncpy(slashpath,mask,MaxPATH);
    strplus(slashpath,"\\",MaxPATH);
    return slashpath;
  }
  return
  mask;
}

#endif


_f notminus(char *arg) {
  return arg[2] != '-';
}



int main(int argc, char *argv[]) {
  int i;
  char *mask=NULL, *p;
  long sizeoid;
  int sortstyle=SortByExt;

  installbreak();

#if LFNS
  if (stristr(argv[0],"dos"))
  dosanyway=YES;
#endif

  origwd=OVgetcwd(NULL,MaxPath);
  thedriveletter=getdisk()+'a';

  for (i=1; i<argc; ++i) {
    if (argv[i][0]==opmark) {
      switch (argv[i][1]) {
        case 0: break;
        /* make option alone OK, so he can use files with -. */

        case 'a':
        includedirs=notminus(argv[i]);
#if ONLY_DIR
        if (argv[i][1]=='a')
        onlydirs=YES;
#endif
        break;

        case 'c':
        nobaredrive=YES;
/* fall thru to 'B'. */

        case 'B':
        true=YES;
#if EXTOP
        noextension=NO;
#endif
/* fall thru to case 'b'. */
        case 'b':
#if BAREWIDE
        boption = YES;
#endif
        baretrail=argv[i]+2;
#if !BAREWIDE
        wide=NO;
#endif
        includedirs=NO;

        CASEB:
        bare=YES;
        break;

        case '.': dotstyle=YES; break;
        case 'd': sortstyle=SortByDate; break;
        case 'e': sortstyle=SortByExt; break;
        case 'f': effchars = argv[i]+2; break;
        case 'n': sortstyle=SortByName; break;
#if PREFIX
        case 'p': prefix=argv[i]+2; break;
#endif

#if QUOTES
        case 'q': quotes=notminus(argv[i]); break;
#endif
        case 's': sortstyle=SortBySize; break;
        case 't': military=YES; break;
        case 'u': sortstyle=sortNOT; break;
        case 'w': wide=YES; goto CASEB;

#if EXTOP
        case 'x': noextension=YES; true=NO; break;
#endif

        case 'y': trailer_anyway = YES; break;

        case 'z': bytes_left = YES; break;

        case '/':
        subs=YES;
        includedirs=NO;
        diranyway=NO;
        break;

        case ':':
        attract=ATTOR;
        attributes=0;
        p=argv[i]+2;
        while(*p) {
          switch(*p) {
            case '&': attract=ATTAND; break;
            case 'a': attributes|=FA_ARCH; break;
            case 'r': attributes|=FA_RDONLY; break;
            case 's': attributes|=FA_SYSTEM; break;
            case 'h': attributes|=FA_HIDDEN; break;
            default:
            depart();
          }
          ++p;
        }
        break;

        default:
        depart();
      }
    }
    else if (!mask) mask=argv[i];
    else depart();
  }


  if (!mask) {
#if LFNS
    if (win95())
    mask="*";
    else
#endif
    mask="*.*";
  }

  if (setdrive(&mask)) {
    fprintf(errout,"Couldn't change drives.");
    exeunt(1);
  }

  if ( (sizeoid=((coreleft()/5L)*4L))>0xFFFFL)
  sizeoid=0xFFFFL;

  if (!(files=malloc(sizeoid))) {
    fprintf(errout,"Couldn't malloc().");
    exeunt(7);
  }

  maxfiles=sizeoid/sizeof(DIRENTRY)-1;

  if (subs) {
    char newpath[MaxPath], drive[MAXDRIVE], dir[MAXDIR], file[MAXFILE],
    ext[MAXEXT], newmask[MaxPATH];

    hycount=0;

    if (slashed(mask)) {
      fnmerge(newmask,NULL,NULL,"*",".*");
      if (setpath(mask)) {
        fprintf(errout,"chdir (%s) failed.\n",mask);
        exeunt(38);
      }
    }
    else {
      fnsplit(mask,drive,dir,file,ext);
      fnmerge(newpath,drive,dir,NULL,NULL);
      fnmerge(newmask,NULL,NULL,file,ext);
      slashed(newpath);
      if (setpath(newpath)) {
        fprintf(errout,"chdir (%s) failed.\n",newpath);
        exeunt(38);
      }
    }
    OVdirectories(stdout,newmask,sortstyle);
  }
  else {
#if ONEDIR
    if (itsonedir(mask))
    mask=slash(mask);
#endif

    dirintro(LOGCLEAR,NULL);
    dirintro(LOGBUMP,NULL);
    OVshowfiles(stdout,mask,sortstyle);

    exeunt(0);
  }

  exeunt(0);

}


