/* jgodir95.c    Thu 09-07-1995
Thu 09-07-1995  creation.
*/

#include "jgodir.h"

#define JGODIR YES    /* condition-out the OV things. */

#define TEST NO

/****************************************************************************
this code is to fix simple problems with FIXWIN95 directories & etc., like
half of 'em are hidden....
****************************************************************************/

#if FIXWIN95


enum FINDWHAT {
  FINDDIR = 1,
  FINDFILE = 2
};

enum FINDWHAT findwhat;

/* this'll find directories, but only if attr == FA_DIREC, i.e. just wants
directories. JGO_OK flag indicates use original functionality anyway. // I
never figgered out what this meant -- wasn't implemented correctly as far as
I could tell -- and now i'm taking it out. // Oh *I* see; I used JGO_OK so
attr *wouldn't* equal FA_DIREC. Got it.... Leave it this way I think. I
guess... */

_f unsigned findfirstdos(const char *pathname, struct ffblk *ffblk, int attr) {
  if (attr == FA_DIREC) {
    int result;
    findwhat=FINDDIR;
    attr = FA_DIREC|FA_RDONLY|FA_HIDDEN|FA_SYSTEM;
    result=findfirst(pathname,ffblk,attr);
    while(!result) {
      if (ffblk->ff_attrib & FA_DIREC)
      return 0;
      result=findnext(ffblk);
    }
    return -1;
  }
  attr &= ~JGO_OK;
  findwhat=FINDFILE;
  return findfirst(pathname,ffblk,attr);
}

_f unsigned findnextdos(struct ffblk *ffblk) {
  if (findwhat == FINDDIR) {
    while(!findnext(ffblk)) {
      if (ffblk->ff_attrib & FA_DIREC)
      return 0;
    }
    return -1;
  }
  return
  findnext(ffblk);
}

#endif



/****************************************************************************
This code tries to make it work with big names.
****************************************************************************/
#if LFNS


#define KILOBYTE (1024)
unsigned _stklen = 16*KILOBYTE;

#define ALLATT (FA_RDONLY|FA_HIDDEN|FA_SYSTEM)

#define DATT (ALLATT|FA_DIREC)

_v union REGS regs;

_v struct SREGS segregs;

/* assumes regs, setup. */
_f void dosreg(void) {
  int86(0x21,&regs,&regs);
}

/* assumes regs, segregs, setup. */
_f void dosseg(void) {
  int86x(0x21,&regs,&regs,&segregs);
}

#if !FIXWIN95
  #error FIXWIN95 should be true
#endif

/****************************************************************************
See page 520, Programmer's Guide to Microsoft Windows 95.

must and search are used to distinguish between files and directories.

  To return files only:
    set must to zero
    set search to usual attributes.

  To return directories only:
    set must to FA_DIREC.
    set search to usual attributes|FA_DIREC.

  To return files and directories:
    set must to 0.?
    set search to usual attributes|FA_DIREC.

I've set it up so it'll dispose of the handle thingey when a new findfirst
starts, and can be called with fblock==NULL to dispose of the last one if any.

Don't anything with the unicode right now.

Wfindfirst sets FBLOCK95.handle to -1; if successful, it sets it to the stupid
handle thingey. I'm assuming that if Wfindfirst fails, there is no need to do
Wfindclose -- although you *can* do it and it'll do nothing, because of the -1
handle in FBLOCK95.

The original.
typedef struct {
  BIG dwFileAttributes;
  BIG ftCreationTime;
  BIG ftLastAccessTime;
  BIG ftLastWriteTime;
  BIG nFilesSizeHigh;
  BIG nFileSizeLow;
  WORD r1, r2;
  char cFileName[256];    !!! no actually turned-out 260.
  char cAlternateFileName[14];
} WIN32_FIND_DATA;


returns -1 if badness, else 0.

****************************************************************************/

static int Wfindfirst(const char *pathname, FBLOCK95 *fblock, int must, int
search) {
  fblock->handle=-1;      /* mark it. */

  regs.x.ax=0x714e;
  regs.h.ch=must;
  regs.h.cl=search;

  regs.x.dx=      FP_OFF(pathname);
  segregs.ds=   FP_SEG(pathname);

  regs.x.di =     FP_OFF(fblock);
  segregs.es=   FP_SEG(fblock);

  regs.x.si = 1;    /* old-style time. */


  dosseg();

  if (regs.x.cflag)
  return -1;

  fblock->handle=regs.x.ax;

  fblock->unicode=regs.x.cx;

  return 0;
}

static int Wfindnext(FBLOCK95 *fblock) {
  regs.x.ax=0x714f;
  regs.x.bx=fblock->handle;
  regs.x.di=    FP_OFF(fblock);
  segregs.es= FP_SEG(fblock);
  regs.x.si = 1;

  dosseg();

  fblock->unicode=regs.x.cx;

  return
  regs.x.cflag ? -1 : 0;
}

static int Wfindclose(FBLOCK95 *fblock) {

  if (fblock->handle != -1) {
    regs.x.ax=0x71a1;
    regs.x.bx=fblock->handle;
    int86(0x21,&regs,&regs);
    fblock->handle=-1;
  }
}

_f int Wfind1stonly(const char *pathname, FBLOCK95 *fblock, int must, int
search) {
  int result;
  if (!(result=Wfindfirst(pathname,fblock,must,search)))
  Wfindclose(fblock);
  return result;
}

/****************************************************************************
Wchdir; return -1 if bad else 0
****************************************************************************/

_f int Wchdir(const char *path) {
  regs.x.ax=      0x713b;
  regs.x.dx=      FP_OFF(path);
  segregs.ds=     FP_SEG(path);
  dosseg();
  return
  regs.x.cflag ? -1 : 0;
}

_f int OVchdir(const char *path) {
  if (win95())
  return Wchdir(path);
  return chdir(path);
}

/****************************************************************************
DOS omits drive, colon, slash.

0123
c:\

****************************************************************************/
#define GETDRIVE YES
/* some usux CDROMs return garbage for getcwd i.e. short version. // Fri
12/07/01 2:57 pm Isn't that amusing; now XP is returning short versions
somehow for network drives. // Oh I see this is just for the *drive*. I was
dangerously using the short getcwd() just to get the drive. */

_f char *Wgetcwd(char *buf, int buflen) {
  enum {
    NAME1=3
  };

  char apath[MAX95PATH+NAME1];

#if GETDRIVE
  apath[0]=getdisk()+'A';
  apath[1]=':';
  apath[2]='\\';
#else
  getcwd(apath,MAX95PATH+NAME1);
#endif

  regs.x.ax=      0x7147;
  regs.h.dl=      0;      /* this drive. */
  regs.x.si=      FP_OFF(apath)+NAME1;
  segregs.ds=     FP_SEG(apath);

  dosseg();

  if (regs.x.cflag)
  return NULL;

#if SEELONG
  makelongcwd(apath);
#endif

  if (buf) {
    if (buflen<(strlen(apath)+1))
    return NULL;

    strcpy(buf,apath);
    return buf;
  }

  return
  strdup(apath);

}

/****************************************************************************
****************************************************************************/

_f char *OVgetcwd(char *buf, int buflen) {
  if (win95())
  return Wgetcwd(buf,buflen);
  return getcwd(buf,buflen);
}

/****************************************************************************
I made the last argument mandatory.
****************************************************************************/
int Wxgetsetatt(const char *path, int attrib, int bl) {
  regs.x.ax =   0x7143;
  regs.h.bl =   bl;
  regs.x.cx =   attrib;
  regs.x.dx =   FP_OFF(path);
  segregs.ds =    FP_SEG(path);

  dosseg();

  if (regs.x.cflag)
  return -1;

  return regs.x.cx;
}


_f int Wsetatt(const char *path, int attrib) {
  return
  (Wxgetsetatt(path,attrib,1)<0) ?
  -1 : 0;
}

_f int Wgetatt(const char *path) {
  return
  Wxgetsetatt(path,0,0);
}

_f int W_chmod(const char *path, int func, int attrib) {
  if (func)
  return Wsetatt(path,attrib);
  else
  return Wgetatt(path);
}

int OV_chmod(const char *path, int func, int attrib) {
  if (win95())
  return
  W_chmod(path,func,attrib);

  return
  _chmod(path,func,attrib);
}

/****************************************************************************
****************************************************************************/
static int w95(void) {
  static char longname[]="U";
  char shortname[13];

/* The XP memorial trick.*/
/*if (getenv("NUMBER_OF_PROCESSORS"))
  return WIN95RUNNING;  */

  if (_osmajor <
/*7 */
  5  /* *this* is the XP trick. */
  )
  return 0;

/* so here's my test; try 'n' get a short filename as per PGWIN95, page 537.
*/

  regs.x.ax = 0x71a8;
  segregs.ds = FP_SEG(longname);
  regs.x.si = FP_OFF(longname);
  segregs.es = FP_SEG(shortname);
  regs.x.di = FP_OFF(shortname);
  regs.x.dx = 0x0000;

  dosseg();

  return
  regs.x.cflag ?
  JUSTDOS7 :
  WIN95RUNNING;
}

_v int dosanyway;

_f int win95(void) {
  static BYTE done, what;

  if (done)
  return what;

  done=YES;

  if (dosanyway) {
    return
    what=NO;
  }

  return
  what = (w95() == WIN95RUNNING);

}

/****************************************************************************
*always* read the tree in LFN.

FA_RDONLY  Read-only attribute
FA_HIDDEN  Hidden file
FA_SYSTEM  System file
FA_LABEL   Volume label
FA_DIREC   Directory
FA_ARCH    Archive

****************************************************************************/

#define ALLATT (FA_RDONLY|FA_HIDDEN|FA_SYSTEM) /* 0x07 */

#define DATT (ALLATT|FA_DIREC)                  /* 0x17 */

#define FIX95kdcA NO   /* change find1st second dir atts as per Programmer's
guide to usux Windows 95, page 523. I.e. I'm leaving the above unchanged, but
since they don't correspond to the book.... */
#define FIX95kdcB YES



#if FIX95kdcA
#define DIRmust (0x10)
/* #define DIRsrch (0x17)  /* but I'm adding readonly to this. ? */
#define DIRsrch (0x16)  /* let's try their exact nonsense. */
#else
#define DIRmust FA_DIREC
#define DIRsrch DATT
#endif


_f char *Wfinddir(FBLOCK95 *fblock, int first) {

  if (first) {
    if (Wfindfirst("*",fblock,DIRmust,DIRsrch))
    return NULL;
  }
  else {
    if (Wfindnext(fblock))
    return NULL;
  }
  while (
  (strcmp(fblock->cFileName,".")==0) ||
  (strcmp(fblock->cFileName,"..")==0)
#if NETDIR0
  || (!(fblock->FileAttributes & FA_DIREC))
  /* perhaps it's finding non-directories anyway, see. */
#endif
  )
  {
    if (Wfindnext(fblock))
    return NULL;
  }
  return fblock->cFileName;
}


/****************************************************************************
print 4 digits or less of size, using "k" etc.
****************************************************************************/
#if JGODIR
char *nfoursize(char *result, long size) {
  static BYTE letters[] =  "1KMG";
  int i=0;
  while(size > 999) {
    size /= 1000;
    ++i;
  }

  if (letters[i]=='1')
  sprintf(result,"%4u",size);
  else {
    sprintf(result,"%3u%c",(WORD)size,letters[i]);
  }
  return
  result;
}
#endif


/****************************************************************************
called if win95().
****************************************************************************/
_f char *ext95(char *s) {
  return
  strrchr(s,'.');
}

_f char *eext95(char *s) {
  static char *empty="";
  char *p;
  if (!(p=ext95(s)))
  p=empty;
  return p;
}


_f void Wmakeafile(DIRENTRY *file, FBLOCK95 *fblock, int sum) {
  int t;
  char *p, *a;

/* do old name. */
  if (!(*(a=fblock->cAlternateFileName)))
  a=fblock->cFileName;

  /* if only one name, alternate's blank. */

  strncpy(file->name,a,Nsize);
  if (p=strchr(a,'.')) {
    if ( (t=p-a) <Nsize)
    file->name[t]='\0';
    strncpy(file->ext,p+1,Xsize);
  }
  else file->ext[0]='\0';
  lowern(file->name,Nsize);
  lowern(file->ext,Xsize);

/* do stupid name. */
  file->lname=strdup(fblock->cFileName);

  file->llength=strlen(file->lname);

/* do stupid name extension. */
  file->lext=eext95(file->lname);

  file->atts=fblock->FileAttributes;
  file->size=fblock->nFileSizeLow;

  nfoursize(file->ksize,file->size);    /* make a quick abbreviation of size.
                                        */

  file->date=fblock->ftLastWriteTime.Low.dos.date;
  file->time=fblock->ftLastWriteTime.Low.dos.time;

  if (fblock->FileAttributes & FA_DIREC) {
    file->stat = dstatDIR;
    if (sum)
    ++dircount;
  }
  else {
    file->stat = 0;
    if (sum)
    bytesize += file->size;
  }
}

/****************************************************************************
****************************************************************************/
#if QUOTES
_f char *maybe_quote(char *fname) {
  static char quotes[MaxPath+4];
  if (quotes && strchr(fname,' ')) {
    strcpy(quotes,"\"");
    strcat(quotes,fname);
    strcat(quotes,"\"");
    return quotes;
  }

  return fname;
}

#endif


/****************************************************************************
         10        20        30        40
12345678901234567890123456789012345678901234567890
 old          11-03-95  3:41p (directory)
 ovdir2   c    4-08-96 10:57a      22,529 a
 ovenv    c    4-03-96 10:44a      14,394 a
 ovfiles  c    4-08-96 11:00a       8,259 a
 ovwin95  c    4-08-96 11:09a      30,837 abcd
 A giant directory of fools+ <--- "more" marker.


                              +04-08-96 10:57a
                                           dir
                              "            dir"

                                      999 abcd
                                       1K
                                   + 123M
                                      dir

****************************************************************************/
/* so this one is only called if show95 and should show the big names. */
_f Wshowafilep(FILE *where, DIRENTRY *file) {
  int t, temp;
  char *left=nothing, *right=nothing;

  if (isCc)
  exeunt(19);

#if EXTOP
  file = extensionoid(file);
#endif

#if !ExcludeINSHOFILES
  if (!goodatterbutes(file->atts))
  return;
#endif

  if (file->stat & dstatDIR) {
#if !ExcludeINSHOFILES
    if (!includedirs)
    return;
#endif

#if ONLY_DIR
    if (!onlydirs) {
      left="[";
      right="]";
    }
#else
    left="[";
    right="]";
#endif
  }

#if ONLY_DIR
  if (
  (onlydirs) &&
  (!(file->stat & dstatDIR))
  )
  return;
#endif

  if (bare) {
    if (true) {
      char *dp, d[MaxPath], s[MaxPath];
      sprintf(s,"%s", file->lname);
      trueername(d,s);

/*    lowern(d,9999); */
      if (nobaredrive && d[0] && (d[1]==':'))
      dp=d+2;
      else
      dp=d;

      fprintf(where,

#if PREFIX
      "%s"
#endif

      "%s%s%s%s\n",

#if PREFIX
      prefix,
#endif

      left,
      dp,
      right,
      baretrail);
      return;
    }

    showcount += (t=fprintf(where,
#if PREFIX
    "%s"
#endif
    "%s%s%s%s",
#if PREFIX
    prefix,
#endif
    left,
#if QUOTES
    maybe_quote(file->lname),
#else
    file->lname,
#endif
    right,
    baretrail));
    if (wide) {
      if (showcount>=WIDELINE) {
        fputc('\n',where);
        showcount=0;
      }
      else {                    /*123*/
        temp = 0;
        showcount+=fprintf(where,"   ");   /* mandatory spaces please. */
        t+=3;   /* so I cheated. */
        t %= WIDEFIELD;
        while(t<WIDEFIELD) {
          ++temp;
/*        fputc(' ',where); */
          ++showcount;
          ++t;
        }

        if (showcount>=WIDELINE) {
          fputc('\n',where);
          showcount=0;
        }
        else {
          while(temp--)
          fputc(' ',where);
        }
      }
    }
    else
    fputc('\n',where);
    return;
  }
  if (dotstyle && *file->ext) {
    t=fprintf(where,
    "%c%.8s.%.3s ",
    showmark(file->stat),
    file->name,
    file->ext);
    if (t>0) {
      while(t++<14)
      putchar(' ');
    }

    fprintf(where,
    "%2u-%02u-%02u %s ",
    MONTH(file->date),
    DATE(file->date),
    YEAR(file->date),
    showtime((FFTIME*) &file->time)
    );
  }
  else {
    fprintf(where,
    "%c%-8.8s %-3.3s %2u-%02u-%02u %s ",
    showmark(file->stat),
    file->name,
    file->ext,
    MONTH(file->date),
    DATE(file->date),
    YEAR(file->date),
    showtime((FFTIME*) &file->time)
    );
  }

  if (file->stat & dstatDIR)
  fprintf(where,"(directory) %s",
  showatts(file->atts));
  else
  fprintf(where,
  "%11.s %s",
  commad(file->size,11),
  showatts(file->atts)
  );

  fprintf(where," %s\n",file->lname);
}


/****************************************************************************
****************************************************************************/
_f int WfSortByName(const DIRENTRY **one, const DIRENTRY **two) {
  int result;
  if (result=fixdirsort(one,two))
  return result;
  return
  stricmp((*one)->lname,(*two)->lname);
}

_f int WfSortByExt(const DIRENTRY **one, const DIRENTRY **two) {
  int result;
  if (result=fixdirsort(one,two))
  return result;

  if (result=stricmp((*one)->lext,(*two)->lext))
  return result;

  return stricmp((*one)->lname,(*two)->lname);
}

/****************************************************************************
****************************************************************************/
#define XP_OD1 YES

#if XP_OD1
BIG Wlastthis_length;
#endif

_f void Wdirectories(FILE *where, char *mask, int sortstyle) {
  char *thisdir, *newdir;
  FBLOCK95 fblock;

  if (isCc)
  exeunt(19);

  dirintro(LOGCLEAR,NULL);
  dirintro(LOGBUMP,NULL);
  dirintro(LOGHYPHENS,NULL);

  Wshowfiles(where,mask,sortstyle);

  if (!(thisdir=Wgetcwd(NULL,MaxPath)))
  return;

#if XP_OD1
  {
    BIG x;
    x = strlen(thisdir);

    if (x>Wlastthis_length)
    Wlastthis_length = x;

    if ((x==3) && (Wlastthis_length>3))
    return;
    /* trap ridiculous c:\ */
  }
#endif

  if (newdir=Wfinddir(&fblock,YES)) {
    do {
#if TEST
      fprintf(stderr,"%s\\%s\n",thisdir,newdir);
#endif
      if (setpath(newdir)) {
        fprintf(errout,"chdir failed: in {%s}, to {%s}\n",thisdir,newdir);
        /* exeunt(37); */ /* No no keep going. */
      }
      else
      Wdirectories(where,mask,sortstyle);
      setpath(thisdir);
    }
    while(newdir=Wfinddir(&fblock,NO));
    Wfindclose(&fblock);
  }
  free(thisdir);
}

_f void OVdirectories(FILE *where, char *mask, int sortstyle) {
#if XP_OD1
  Wlastthis_length = 0;
#endif
  if (win95())
  Wdirectories(where,mask,sortstyle);
  else
  directories(where,mask,sortstyle);
}

/****************************************************************************
****************************************************************************/
_f int seefile(FBLOCK95 *fblock) {
    return
  (!!strcmp(fblock->cFileName,".")) &&
  (!!strcmp(fblock->cFileName,".."))
  ;
}


_f void Wshowfiles(FILE *where, char *mask, int sortstyle) {
  DIRENTRY adir;
  FBLOCK95 fblock;
  int idx=0, result, eff;

  if (isCc)
  exeunt(19);

  dircount=nfiles=0;
  bytesize=0;

  if (!(fnsplit(mask,drive,dir,file,ext) & (FILENAME|EXTENSION))) {
    fnmerge(newmask,drive,dir,"*",NULL);
    mask=newmask;
  }

#if JGODIR
#if DOTCRASH
  /* so maybe we can just do nothing? I can't find the cwd being used, at
  least not below. // no apparently somebody uses it. */
  Wgetcwd(cwd,MaxPath);
#else
  trueername(cwd,".");
#endif
#else
  trueername(cwd,mask);
  result=fnsplit(cwd,drive,dir,NULL,NULL);
  fnmerge(cwd,drive,dir,NULL,NULL);
#endif

/*lowern(cwd,MaxPath); */

  bytesize=0;
  result=Wfindfirst(mask,&fblock,0,GETSTAT);
  dircount=0;
  while(!result) {

    if (isCc)
    exeunt(19);

#if ExcludeINSHOFILES
    if (
    (!goodatterbutes(fblock.FileAttributes)) ||
    ( (fblock.FileAttributes & FA_DIREC) && (!includedirs) )
    )
    goto TRYAGAIN;
#endif

    if (seefile(&fblock)) {  /* skip dumb stuff. */

      if (effchars)
      for (eff=0; effchars[eff]; ++eff) {
        if (strichr(fblock.cFileName,effchars[eff]))
        goto TRYAGAIN;
      }

      dirintro(HEADIT,where);

      if (!sortstyle) {
        Wmakeafile(&adir,&fblock,YES);
        Wshowafilep(where,&adir);
      }
      else {
        Wmakeafile(files+nfiles,&fblock,YES);
      }
      if (sortstyle && (++nfiles > maxfiles)) {
        /* abort to unsorted. */
        for (idx=0; idx<nfiles; ++idx) {
          Wshowafilep(where,files+idx);
        }
        sortstyle=sortNOT;
      }
    }
    TRYAGAIN:
    result=Wfindnext(&fblock);
  }

  Wfindclose(&fblock);

  if (sortstyle) {
    whosort(sortstyle,nfiles);
    for (idx=0; idx<nfiles; ++idx) {
      Wshowafilep(where,files+idx);
    }
  }

  dirtrailer(where);

}


_f void OVshowfiles(FILE *where, char *mask, int sortstyle) {
  if (win95())
  Wshowfiles(where,mask,sortstyle);
  else
  showfiles(where,mask,sortstyle);
}

/****************************************************************************
****************************************************************************/
/* dst must be 128 bytes or more (undoc dos p. 565.) */
_f void Wtruename(char *dst, char *source) {
  regs.x.ax=        0x7160;
/*regs.x.cx=        0x8000;
  /* don't xlate subs; get full path. */

#if 0
  if (*source=='*') {
    regs.x.cx=        0x8002;
  /* don't xlate subs; get long path? */
    *source='.';     /* trickery. It won't get nonexistent file. */
  }
#endif
  regs.x.cx=        0x8002;

  segregs.ds=       FP_SEG(source);
  regs.x.si=        FP_OFF(source);
  segregs.es=       FP_SEG(dst);
  regs.x.di=        FP_OFF(dst);

  dosseg();
}


_f void OVtruename(char *dst, char *source) {
  if (win95())
  Wtruename(dst,source);
  else
  truename(dst,source);
}




#endif        /* if LFN */

