/****************************************************************************
jgodir.c
Wed 12-15-1993  creation, from ovdir.c.

Fri 2/25/2011 1:29 pm. The Great 32-bit Resurrection. Note that odd "WIN32"
strewn here and there will probably *not* support compilation in 16-bit mode
if made false; they're just sort of breadcrumbs, the story of the thing.

===============================================================================
This software is copyrighted under a BSD-style license as follows. Copyright
(c) 2011, James Gregor Owen All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.

* Neither the name of the author nor the names of any associates may be used
to endorse or promote products derived from this software without specific
prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

j.g. owen * * * * * * * * * * * * *
web: http://owenlabs.org/
email: owen_bda4@yahoo.com
* * * * * * * * * * * * * * * * * *

****************************************************************************/

#include "jgodir.h"
//#include <sysutils.hpp>

/****************************************************************************
****************************************************************************/
#if WIN32
//  #define findfirstdos findfirst
//  #define findnextdos findnext
//but I'm just renaming these....
#endif

/****************************************************************************
****************************************************************************/
_v char cwd[MaxPath];
//_v char truecwd[MaxPath];
_v char drive[MAXDRIVE];
_v char dir[MAXDIR];
_v char file[MAXFILE];
_v char ext[MAXEXT];
_v char newmask[MaxPATH];

_v int dircount, nfiles;

//_v
#if FILE5GIG
__int64 bytesize;
#else
unsigned long bytesize;
#endif

_v char *nothing="";

_v int showcount;

_v WORD hycount;

_v int TrueName=NO;
_v int subs, nobaredrive;
_v int dotstyle, bare;
_v int includedirs=YES;
#if ONLY_DIR
_v int onlydirs;
#endif
_v int wide;
_v char *baretrail="";

#if PREFIX
_v char *prefix="";
#endif

#if QUOTES
_v int quotes;
#endif

_v char *origwd;

_v FILE *errout=stdout;

_v int thedriveletter=0;  /* i.e. for calls what need the drive, this is it. */

_v int military;

#if EXTOP
_v int noextension;
#endif

#if BAREWIDE
_v int boption;
#endif

int attract, attributes;
enum {
  ATTOR=1,
  ATTAND
};

_v char *effchars;

#if WINFindFirst
_v bool CreationTime=YES;
#endif

#define BIGMAX (50000)

int greenwich;  //i might option it someday.

/****************************************************************************
****************************************************************************/
#if WIN32
/****************************************************************************
****************************************************************************/
/****************************************************************************
DWORD WINAPI GetFullPathName(
  __in   LPCTSTR lpFileName,
  __in   DWORD nBufferLength,
  __out  LPTSTR lpBuffer,
  __out  LPTSTR *lpFilePart
);

****************************************************************************/
_f char *fullname(char *fn) {
  static char thename[MAXPATH];

  if (!
  GetFullPathName(
  fn,
  MAXPATH,
  thename,
  NULL))
  return fn;

  return thename;

}

_f void trueername(char *dst, char *source) {
  strncpy(dst,fullname(source),MAXPATH);

//  OVtruename(dst,source);
#if STRANGEnWACKO
/****************************************************************************
I believe   oh look there IS a comment in the original jgodir.c. Which seems
to explain nothing. Whatever. It works without...
****************************************************************************/

  if (!strncmp(dst,"\\\\",2)) {
    char *last, *next;
    int count=127;
    dst[0]=dst[2];
    dst[1]=':';
    dst[2]='\\';

    last=dst+3;
    while(next=strstr(last,".\\"))
    last=next+2;

    count -= last-(dst);
    strncpy(dst+3,last,count);
    dst[127]='\0';
  }
#endif
}


/****************************************************************************
GetDiskFreeSpaceEx

BOOL GetDiskFreeSpaceEx(

LPCTSTR lpDirectoryName,
// pointer to directory name on disk of interest

PULARGE_INTEGER lpFreeBytesAvailableToCaller,
// pointer to variable to receive free bytes on disk available to the caller

PULARGE_INTEGER lpTotalNumberOfBytes,
// pointer to variable to receive number of bytes on disk

PULARGE_INTEGER lpTotalNumberOfFreeBytes
// pointer to variable to receive free bytes on disk

);

The virtuous Delphi version:

extern PACKAGE BOOL __stdcall (*GetDiskFreeSpaceEx)(char * Directory,
__int64 &FreeAvailable, __int64
&TotalSpace, Windows::PLargeInteger TotalFree);

****************************************************************************/

#if WACKO_DELPHIVERSION
__int64 droom(char *path) {
//  ULARGE_INTEGER
  __int64
  UserFree, Total;
  __int64 TotalFree;

  if (!Sysutils::GetDiskFreeSpaceEx(path,
  UserFree,
  Total,
  &TotalFree))

  return 7;

  return TotalFree;

}
#endif


_f __int64 droom(char *path) {
  ULARGE_INTEGER
  UserFree, Total, TotalFree;

//the "::" means DON'T use ambiguous Delphi function.

  if (!::GetDiskFreeSpaceEx(path,
  &UserFree,
  &Total,
  &TotalFree))

  return 7;

  return TotalFree.QuadPart;

}

/****************************************************************************
****************************************************************************/
    #define CREATE_TIME_IMPOSSIBLE YES
    /****************************************************************************
    Fri 2/25/2011 5:52 pm. Well obviously I've gotten too old for this.
    Somewhere in the wilds of windows, usux did something to make it so this
    poor program wouldn't get the CREATE time for directories. Instead it
    shows the WRITTEN time; as indeed it always shows for files. Most people
    are happy with the written time for files, but people, including me,
    expect the create time for directories, and in fact my beautiful Delphi
    OwenShow normally shows them, offering an option to show the written time.
    Which I was planning to do here, but failed. See the pathetic parade of
    GetCreateTime attempts et al.

    I've almost concluded -- out of the usual pathetic programmer's bleak
    desperation -- the problem is probably something to do with running a scan
    of the files i.e. in the main code, and then trying it here. Of course
    that doesn't explain why most of the pitiful attempts worked once, but not
    subsequently, and indeed why some of them fail at all, since they're not
    scanning. But I suspect if I switches to the official winders
    FindFirstFile et al., and got the sacred CreationTime from that record
    obtained in that way, it might work. But then again, it may just be that
    the Delphi wizards, by 2002, knew enough to outwit the usux mediocrities.
    Who knows.... The Delphi wizards are in decline these days anyway. So
    jgodir will report written directory dates now and until I go nuts
    again....

    I really got going there, incidentally, when I discovered I'd left-out all
    the findclose()s, something you didn't have to do in MSDOS. But I put 'em
    in and it didn't seem to make the slightest difference....

    Thu 3/03/2011 12:44 pm. GLORIOUS CONCLUSION. Turns-out my conjecture above
    -- that somehow trying to do a scan, or even get attributes, is somehow
    *interfered-with* by an ongoing scan -- IS TRUE! Oh Usux! Oh Mediocrity! I
    assume that when you do a recursive scan, i.e. of subdirectories, as I
    have been known to do, at least in Delphi, this doesn't apply, because
    then probably *nothing* would work -- but then again, the only refs I
    could find in *minutes* of googling suggested subdir scans were a poor
    idea, and the only guy who seemed to know anything -- i.e. unlike me --
    suggested one should accumulate a list of the subdirs, in a string list,
    and *then* scan them, *after* closing the current scam; I meant, scan.
    Which I may well do more-or-less in my Delphi directory scans....

    Anyway this indented material, is a *monument* to the Wonder of
    Windows.... Note that many of the comments and function prototypes are
    correct, and actually used in the ultimate solution. Which was to use
    Windows FindFirstFile and the WIN32_FIND_DATA structure, and all that
    entails, and it worked happy happy joy joy. (See WINFindFirst conditional
    here and there.)

    ****************************************************************************/
    #if !CREATE_TIME_IMPOSSIBLE
    int creationtime=YES;
    #endif

    /****************************************************************************
    The GetFileTime function retrieves the date and time that a file was
    created, last accessed, and last modified.

    BOOL GetFileTime(

        HANDLE hFile,       // identifies the file
        LPFILETIME lpCreationTime,  // address of creation time
        LPFILETIME lpLastAccessTime,        // address of last access time
        LPFILETIME lpLastWriteTime  // address of last write time
       );

    typedef struct _FILETIME { // ft
        DWORD dwLowDateTime;
        DWORD dwHighDateTime;
    } FILETIME;

    //oh see that was just a little windows foolery! Ha Ha Ha!!!

    BOOL GetFileAttributesEx(

        LPCTSTR lpFileName,         // pointer to string that specifies a file or directory
        GET_FILEEX_INFO_LEVELS fInfoLevelId,        // value that specifies the type of attribute information to obtain
        LPVOID lpFileInformation    // pointer to buffer to receive attribute information
       );

    typedef struct _WIN32_FILE_ATTRIBUTE_DATA{
        DWORD      dwFileAttributes;
        FILETIME   ftCreationTime;
        FILETIME   ftLastAccessTime;
        FILETIME   ftLastWriteTime;
        DWORD      nFileSizeHigh;
        DWORD      nFileSizeLow;
    } WIN32_FILE_ATTRIBUTE_DATA, *LPWIN32_FILE_ATTRIBUTE_DATA;

    BOOL WINAPI FileTimeToDosDateTime(
      __in   const FILETIME *lpFileTime,
      __out  LPWORD lpFatDate,
      __out  LPWORD lpFatTime
    );

    ****************************************************************************/
    #if WINDOWS_ACTUALLY_WORKED_TWICE
    void ClearMemory(unsigned char *where, unsigned int count) {
      for (unsigned int i=0; i<count; ++i) {
        *where++=0;
      }
    }

    bool GetCreateTime(char *fn, unsigned int *fdate, unsigned int *ftime) {

      FILETIME *ft;

      WIN32_FILE_ATTRIBUTE_DATA wad;

      unsigned short adate, atime;

    #if 0
      static char fn[MAXPATH];
      if (!*fn)
      strncpy(fn,cwd,MAXPATH);
      strcat(fn,afn);

      ClearMemory((unsigned char*)&wad,sizeof(wad));
    #endif

      if (!GetFileAttributesEx(
      fn,GetFileExInfoStandard,
      &wad))
      return NO;


      //*fdate = wad.ftCreationTime.dwHighDateTime; //now I'm guessing.
      //*ftime = wad.ftCreationTime.dwLowDateTime;
      //and I was wrong.
      if (!
      FileTimeToDosDateTime(
      &wad.
    //  ftCreationTime
    //  ftLastAccessTime
      ftLastWriteTime
      ,
      &adate,
      &atime
      ))
      return NO;
      ;
      //now that's ril likely.... //wasn't as it turned out....

      *fdate = adate;
      *ftime = atime;

      return YES;

    }
    #endif

    /****************************************************************************
    struct TSearchRec

    {
            int Time;
            int Size;
            int Attr;
            AnsiString Name;
            int ExcludeAttr;
            int FindHandle;
            _WIN32_FIND_DATAA FindData;
    } ;

    typedef struct _WIN32_FIND_DATA {
      DWORD    dwFileAttributes;
      FILETIME ftCreationTime;
      FILETIME ftLastAccessTime;
      FILETIME ftLastWriteTime;
      DWORD    nFileSizeHigh;
      DWORD    nFileSizeLow;
      DWORD    dwReserved0;
      DWORD    dwReserved1;
      TCHAR    cFileName[MAX_PATH];
      TCHAR    cAlternateFileName[14];
    } WIN32_FIND_DATA, *PWIN32_FIND_DATA, *LPWIN32_FIND_DATA;

    ****************************************************************************/

    #if DELPHIworkedBUTITDIDNT
    bool GetCreateTime(char *fn, unsigned int *fdate, unsigned int *ftime) {
      TSearchRec sr;
      unsigned short adate, atime;

      if (FindFirst(fn,faDirectory,sr)) {
        int result=NO;

        if (!
        FileTimeToDosDateTime(
        &sr.FindData.ftCreationTime,
        &adate,
        &atime
        ))
        result = NO;
        ;

        FindClose(sr);

    //    if (result) {

          *fdate = adate;
          *ftime = atime;
    //    }

        return result;
      }
      return NO;
    }
    #endif

    /****************************************************************************
    typedef struct _WIN32_FIND_DATA { // wfd
        DWORD dwFileAttributes;
        FILETIME ftCreationTime;
        FILETIME ftLastAccessTime;
        FILETIME ftLastWriteTime;
        DWORD    nFileSizeHigh;
        DWORD    nFileSizeLow;
        DWORD    dwReserved0;
        DWORD    dwReserved1;
        TCHAR    cFileName[ MAX_PATH ];
        TCHAR    cAlternateFileName[ 14 ];
    } WIN32_FIND_DATA;

    ****************************************************************************/
    #if SOMETHINGWORKED
    bool GetCreateTime(char *fn, unsigned int *fdate, unsigned int *ftime) {
      WIN32_FIND_DATA wdata;
      HANDLE h;
      unsigned short adate, atime;

      if (
      (h=FindFirstFile(fn,&wdata))==INVALID_HANDLE_VALUE
      )
      return NO;

      FindClose(h);

      if (!
      FileTimeToDosDateTime(
      &wdata.ftCreationTime,
      &adate,
      &atime
      ))
    //  return NO;
      ;

      *fdate = adate;
      *ftime = atime;

      return YES;
    }

    #endif
/****************************************************************************
****************************************************************************/

#endif  //if WIN32.



/****************************************************************************
****************************************************************************/
_f void lowern(char *p, int max) {
  while (max-- && (*p=tolower(*p))) ++p;
}

_f const char *strichr(const char *s, int c) {
  int i, lc, uc;
  lc = tolower(c);
  if ((uc = toupper(c))==lc)
  return strchr(s,c);

  for (i=0; s[i]; ++i) {
    if (
    (s[i]==lc) ||
    (s[i]==uc)
    )
    return s+i;
  }
  return NULL;
}


/****************************************************************************
lessee: int 21h function 69h:          page 743 Undoc Dos, 2nd edition.
                         440D, CX=0866 page 692 ditto
acherly turns-out neither of these acherly works; the old DOS guy does. Sigh.
****************************************************************************/
/* this one for DOS 3 or less. */
_f char *volname(void) {
  static char mask[]="c:*.*";
  static char name[15];
  char *p;
  struct ffblk ffblk;
  mask[0]=thedriveletter;
  name[0]='\0';
  if (!findfirst(mask,&ffblk,FA_LABEL)) {
    strcpy(name,ffblk.ff_name);
    findclose(&ffblk);
/*   01234567890
says GATEFORK.ED
*/
    if ( (p=strchr(name,'.')) && ((p-name)==8) ) {
      while (p[0]=p[1])
      ++p;
    }
  }
  return name;
}

char *parenname(void) {
  static char name[35];
  char *p;

  if (*(p=volname())) {
    sprintf(name,"(%s) ",p);
    lowern(name,999);
    return name;
  }

  return nothing;
}


/****************************************************************************
****************************************************************************/
#if (!WIN32)
/* dst must be 128 bytes or more (undoc dos p. 565.) */
_f void truename(char *dst, char *source) {
  union REGS regs;
  struct SREGS segs;
#if !__COMPACT__
/*   #error Didn't test in anything but compact. */
#endif
  segs.ds  =FP_SEG(source);
  regs.x.si=FP_OFF(source);
  segs.es  =FP_SEG(dst);
  regs.x.di=FP_OFF(dst);
  regs.h.ah=0x60;
  intdosx(&regs,&regs,&segs);
}

/*************************************************************************
So
012345678
\\d.\a.\
d:\

  if (directory begins with \\) {
    driveletter is directory[2]
    pickup drivel starting at 7.
  }

I mean, why not? // Well according to these stupid books, the form may change.
The "illegal" form is .\; normally the dot only appears if there *is* an
extension. And then on the other hand, apparently lunatics will have names
like PHANTOM H:\ so it's all pretty hopeless.... // Nah it's fine. See the
only reason I getting all fussed-up was because I thought I needed the drive
letter to get the label. But of course I can get the *current drive* when I
start-up, or the user's specification when I *set* the drive, and do it
without tears. So all this pain and suffering was totally unnecessary.
*************************************************************************/
_f void trueername(char *dst, char *source) {
  OVtruename(dst,source);
  if (!strncmp(dst,"\\\\",2)) {
    char *last, *next;
    int count=127;
    dst[0]=dst[2];
    dst[1]=':';
    dst[2]='\\';

    last=dst+3;
    while(next=strstr(last,".\\"))
    last=next+2;

    count -= last-(dst);

    strncpy(dst+3,last,count);
    dst[127]='\0';
  }
}

#endif  /* if !WIN32 */
/****************************************************************************
****************************************************************************/


_f char *lastchar(char *s) {
  if (!*s) return s;
  return s+strlen(s)-1;
}

/* if terminated with \\, deletes that, returns YES. else NO. */
_f int slashed(char *s) {
  char *p;
  if (*(p=lastchar(s))=='\\') {
    if (strcmp(s+1,":\\") && strcmp(s,"\\") )
    *p='\0';
    return YES;
  }
  return NO;
}

_f char *stristr(char *target, char *what) {
  int length;
  if (length=strlen(what)) {
    while (*target) {
      if (!(strnicmp(target,what,length))) return target;
      ++target;
    }
  }
  return NULL;
}



/****************************************************************************
****************************************************************************/
#if (!WIN32)
_v int isCc=NO;      /* YES when ^C. */
int origctlbk=0;

void interrupt(*old1bh)();
void interrupt(*old23h)();

void interrupt new1bh() {
  isCc=YES;
}

void interrupt new23h() {
  isCc=YES;
}

_f void installbreak(void) {
  origctlbk=getcbrk();
  setcbrk(0);
  old1bh=getvect(0x1b);
  old23h=getvect(0x23);
  setvect(0x23,new23h);
  setvect(0x1b,new1bh);
}

_f void removebreak(void) {
  setvect(0x1b,old1bh);
  setvect(0x23,old23h);
  setcbrk(origctlbk);
}

#endif

/****************************************************************************
****************************************************************************/
/****************************************************************************
Shoudl be like

  Defines:
    FA_RDONLY     Read-only attribute
    FA_HIDDEN     Hidden file
    FA_SYSTEM     System file
    FA_LABEL      Volume label
    FA_DIREC      Directory
    FA_ARCH       Archive

  Defined in dos.h


 junk          3-17-92  4:44p (directory)
 old           5-18-93 10:26a (directory)
 swap          2-16-93  1:11p (directory)
 business     10-08-92  7:04p      16,178
 edir         11-17-93  7:58p       6,067
 log          10-13-93  4:03p      56,686
 readme        3-02-93 10:47a       1,539
 bingo    aaa  4-27-92  9:57a           8
 shasm    asm 10-08-92  4:24p       2,448
 swap     asm  2-16-93  1:35p      86,628
 jgodir   bak 12-15-93  9:52a       4,039 a
 abatch   bat 10-22-92  4:16p         231
 all      bat 12-03-93 12:51p       4,135 a
 altc     bat 10-13-93  8:37p         106
 altm     bat  9-27-93 12:38p          90
****************************************************************************/

_v DIRENTRY *files;
_v long maxfiles;



/****************************************************************************
****************************************************************************/
_f char *showatts(int atts) {
/*
FA_RDONLY     Read-only attribute *
FA_HIDDEN     Hidden file         *
FA_SYSTEM     System file
FA_LABEL      Volume label
FA_DIREC      Directory
FA_ARCH       Archive             *
*/
  static char someatts[]="WXYZ";
  strcpy(someatts,"    ");
  if (atts & FA_ARCH) someatts[0]='a';
  if (atts & FA_RDONLY) someatts[1]='r';
  if (atts & FA_HIDDEN) someatts[2]='h';
  if (atts & FA_SYSTEM) someatts[3]='s';
  return someatts;
}

/* returns 0 for a, etc. */
_f int retdrive(char *path) {
  int c;
  if ( (path[1]==':') &&
  ( ((c=toupper(*path)) >='A') ||
  (c <= 'M'))) return c-'A';
  return getdisk();
}


#if !WIN32
/* where driven is 0 .. for A... */
long room(int driven) {
  struct dfree dtable;
  getdfree(driven+1,&dtable);
  if (dtable.df_sclus == 0xffff) return 0;
  return
  (long)dtable.df_avail *
  (long)dtable.df_sclus *
  (long)dtable.df_bsec
  ;
}

long droom(char *path) {
  return room(retdrive(path));
}
#endif

_f int showmark(int filestat) {
  if (filestat & dstatDONE) return '*';
  if (filestat & dstatMARKED) return '+';
  return ' ';
}

_f char *commad(__int64 value, unsigned max) {
  LOCALK { NSIZE=25 };
  static char dst[NSIZE];
  char anumber[NSIZE];
  char *s=anumber, *d=dst;
  int comma
#if GIGAK
  , k=NO
#endif
  ;


#if GIGAK
  if ((BIG)value >= 1000000000) {
    (BIG)value /= 1000;
    k=YES;
  }
#endif

  sprintf(anumber,
//  "%ld"
  "%Lu"
  ,value);
  comma=strlen(anumber);
  while(1) {
    *d++=*s++;
    if (!*s) break;
    if (! (--comma % 3)) {
      *d++ = ',';
      comma=3;
    }
  }
  *d='\0';

#if GIGAK
  if (k) {
    *d++='k';
    *d='\0';
  }
#endif

  if (strlen(dst) > max) {
    strcpy(dst+max-2,"..");
  }
  return dst;
}

_f char *showtime(FFTIME *time) {
  int hour, ampm;
  static char atime[]="00:00a";

  if (!time->time) {
    strcpy(atime,     "      ");
    return atime;
  }

  hour = time->bits.hours;

  if (military) {
    ampm=' ';
  }
  else {
    if (hour >= 12)
    ampm='p';
    else
    ampm='a';
    if (hour >12)
    hour -= 12;
  }
  sprintf(atime,"%2d:%02d%c",
  hour,time->bits.minutes,ampm);
  return atime;
}

/* like chdir, except works (does drive too); returns -1 if badness. */
_f int setpath(char *path) {
  int drive;
  if (!path || !*path)
  return NO;        /* do nothing */
  if (path[0] && (path[1]==':') ) { /* do drive spec please! */
    drive= (AD1(path[0])) -1;   /* a|A.. ==> 0.. */
    setdisk(drive);
    if (getdisk() != drive) return -1;
    if (!path[2]) return 0;      /* JUST a drive spec. */
  }
  return OVchdir(path);
}

/* #define chdir setpath /* I just changed them please. */


/****************************************************************************
****************************************************************************/
/******************************************************************/
fixdirsort(const DIRENTRY *one, const DIRENTRY *two) {
  return ((two)->stat & dstatDIR) - ((one)->stat & dstatDIR);
}

int fSortByName(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two)) return result;
  if (!(result=strncmp((one)->name,(two)->name,Nsize)))
  return strncmp((one)->ext,(two)->ext,Xsize);
  return result;
}

int fSortByExt(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two)) return result;
  if (!(result=strncmp((one)->ext,(two)->ext,Xsize)))
  return strncmp((one)->name,(two)->name,Nsize);
  return result;
}


int fSortBySize(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two))
  return result;

  if ((one)->size == (two)->size)
  return fSortByName(one,two);

  if ((one)->size < (two)->size) return -1;
  return 1;
}

int fSortByDate(const DIRENTRY *one, const DIRENTRY *two) {
  int result;
  if (result=fixdirsort(one,two)) return result;
  if (!(result=((one)->date - (two)->date)) &&
  !(result=((one)->time - (two)->time))
  )
  return fSortByName(one,two);
  return result;
}


void whosort(int sortstyle, int nfiles) {
/*  int(*fcmp)(const void *, const void *); */
  int(*fcmp)(const DIRENTRY *, const DIRENTRY *);
  switch(sortstyle) {
    case SortByName:  fcmp=fSortByName; break;
    case SortByExt:   fcmp=fSortByExt; break;
    case SortBySize:  fcmp=fSortBySize; break;
    case SortByDate:  fcmp=fSortByDate; break;
    default:
    return;
  }
  qsort(files,nfiles,sizeof(DIRENTRY),
  (int(*)(const void*, const void*))fcmp
/****************************************************************************
Thu 2/24/2011 2:07 pm. i mean I obviously fought with this in the first round,
but is that not CODING! ... Hallelujah brothers! I *feel* the code!!!
****************************************************************************/

  );
}

/****************************************************************************
****************************************************************************/
_v int headed;
_v int diranyway=YES;
_v int trailer_anyway;
#if TOTALBYTES
_v int totalbytes;
_v __int64 totalByteCount;
#endif





#if WIN32
_v int bytes_left=YES;
#else
   int bytes_left=NO;
#endif

_f void dirintro(int behavior, FILE *where) {
  static int bump, hyphens;
  switch (behavior) {
    case LOGCLEAR:
    headed=bump=hyphens=NO;
    break;

    case LOGBUMP:         bump=YES;                 break;
    case LOGHYPHENS:      hyphens=YES;              break;

    case HEADITANYWAY:
    if (!diranyway)
    return;

    case HEADIT:
    if (headed)
    return;

    headed=YES;

    if (bump)
    showbump(where);


    if (hycount && hyphens &&
#if BAREWIDE
    (!boption)
#else
    ((!bare) || wide )
#endif
    )
    {
      fprintf(where,
      "--------------------------------------------------------\n");
    }
    hycount=YES;

    if
#if BAREWIDE
    (!boption)
#else
    (!bare || wide)
#endif

    fprintf(where,
    "directory of %s%s\n",parenname(),cwd);

    bump=hyphens=NO;
    break;
  }
}

_f void dirtrailer(FILE *where) {
#if BAREWIDE
  if (boption && (!trailer_anyway))
  return;
#endif

  if (diranyway)
  dirintro(HEADIT,where);
  if (headed) {
    if (wide)
    showbump(where);
    else        /* wide always does summary. */
    if (bare && (!trailer_anyway))
    return;

    /* do the summary. */

    fprintf(where,
    "%u files, ",
    nfiles-dircount);

    if (includedirs)
    fprintf(where,
    "%u directories, ",
    dircount);

    fprintf(where,
    "%s bytes",
    commad(bytesize,15)
    );

/****************************************************************************
Thu 4/24/2008 1:54 pm. So just stop printing the bytes left, unless -z,
because it's almost always wrong.
****************************************************************************/
    if (bytes_left)
    fprintf(where,
    ", %s bytes free  ",
    commad(droom(cwd),15)
    );

    showcount=1;        /* fake \n request. */
  }
}


/******************************************************************/

/*****************************************************************
12345678.BOI 10,123,123 03-09-92 12:20a ARH
12345678.BOI 03-09-92 12:20a ARH 10,123,123 <-- ?
*/

int goodatterbutes(int atts) {
  if (attributes) {
    switch (attract) {
/*    case 0: */
      default: return YES;

      case ATTOR:
      if (atts & attributes)
      return YES;
      break;

      case ATTAND:
      if ((atts & attributes) == attributes)
      return YES;
      break;
    }
    return NO;
  }
  return YES;
}

#if EXTOP
_f DIRENTRY *extensionoid(DIRENTRY *file) {
  static DIRENTRY phony;
  char *p;

  if (!noextension)
  return file;

  phony = *file;
  phony.ext[0]='\0';
#if LFNS
  phony.lext = "";
  if (p=strrchr(phony.lname,'.'))
  *p = '\0';
#endif

  return &phony;

}
#endif

/****************************************************************************
****************************************************************************/

/****************************************************************************
the original for this would be JGODIR95.c:showafilep.
****************************************************************************/
_f void showafilep(FILE *where, DIRENTRY *file) {
  int t, temp;
  char *left=nothing, *right=nothing;

#if (!WIN32)
  if (isCc)
  exeunt(19);
#endif

#if EXTOP
  file = extensionoid(file);
#endif

#if !ExcludeINSHOFILES
  if (!goodatterbutes(file->atts))
  return;
#endif

  if (file->stat & dstatDIR) {
#if !ExcludeINSHOFILES
    if (!includedirs)
    return;
#endif

#if ONLY_DIRS
    if (!onlydirs) {
      left="[";
      right="]";
    }
#else
    left="[";
    right="]";
#endif
  }

#if ONLY_DIR
  if (
  (onlydirs) &&
  (!(file->stat & dstatDIR))
  )
  return;
#endif

  if (bare) {
    if (TrueName) {
      char *dp, d[MaxPath], s[MaxPath];

      sprintf(s,"%.8s%s%.3s",
      file->name,
      (*file->ext ? "." : nothing),
      file->ext);
      trueername(d,s);

      lowern(d,9999);
      if (nobaredrive && d[0] && (d[1]==':'))
      dp=d+2;
      else
      dp=d;

      fprintf(where,
#if PREFIX
      "%s"
#endif
      "%s%s%s%s\n",

#if PREFIX
      prefix,
#endif
      left,
      dp,
      right,
      baretrail);
      return;
    }

    showcount += (t=fprintf(where,
#if PREFIX
    "%s"
#endif
    "%s%s%s%s",
#if PREFIX
    prefix,
#endif
    left,
    file->lname,
    right,
    baretrail));
    if (wide) {
      if (showcount>=WIDELINE) {
        fputc('\n',where);
        showcount=0;
      }
      else {                    /*123*/
        temp = 0;
        showcount+=fprintf(where,"   ");   /* mandatory spaces please. */
        t+=3;   /* so I cheated. */
        t %= WIDEFIELD;
        while(t<WIDEFIELD) {
          ++temp;
/*        fputc(' ',where); */
          ++showcount;
          ++t;
        }

        if (showcount>=WIDELINE) {
          fputc('\n',where);
          showcount=0;
        }
        else {
          while(temp--)
          fputc(' ',where);
        }
      }
    }
    else
    fputc('\n',where);
    return;
  }

  if (dotstyle && *file->ext) {
    t=fprintf(where,
    "%c%.8s.%.3s ",
    showmark(file->stat),
    file->name,
    file->ext);
    if (t>0) {
      while(t++<14)
      putchar(' ');
    }

    fprintf(where,
    "%2u-%02u-%02u %s ",
    MONTH(file->date),
    DATE(file->date),
    YEAR(file->date),
    showtime((FFTIME*) &file->time)
    );
  }
  else {
    fprintf(where,
    "%c%-8.8s %-3.3s %2u-%02u-%02u %s ",
    showmark(file->stat),
    file->name,
    file->ext,
    MONTH(file->date),
    DATE(file->date),
    YEAR(file->date),
    showtime((FFTIME*) &file->time)
    );
  }

#if SHOWDIRATTS
  if (file->stat & dstatDIR)
  fprintf(where,"(directory) %s",
  showatts(file->atts));
#else
  if (file->stat & dstatDIR)
  fprintf(where,"(directory)");
#endif
  else
  fprintf(where,
//  "%11.s %s",
  "%11s %s",
  commad(file->size,11),
  showatts(file->atts)
  );
  fprintf(where," %s\n",file->lname);
}


_f void showbump(FILE *where) {
  if ( /* wide && */ showcount)
  fputc('\n',where);
  showcount=0;
}

/****************************************************************************
****************************************************************************/


/****************************************************************************
    typedef struct _WIN32_FIND_DATA {
      DWORD    dwFileAttributes;
      FILETIME ftCreationTime;
      FILETIME ftLastAccessTime;
      FILETIME ftLastWriteTime;
      DWORD    nFileSizeHigh;
      DWORD    nFileSizeLow;
      DWORD    dwReserved0;
      DWORD    dwReserved1;
      TCHAR    cFileName[MAX_PATH];
      TCHAR    cAlternateFileName[14];
    } WIN32_FIND_DATA, *PWIN32_FIND_DATA, *LPWIN32_FIND_DATA;

****************************************************************************/
#if WINFindFirst
  _f void makeafile(DIRENTRY *file, WIN32_FIND_DATA *ffentry, int sum) {
    int t;
    char *p, *oldname;

    if (!*(oldname=ffentry->cAlternateFileName))
    //Windows doesn't maintain the short name unless necessary.
    //so we point to the long name.
    oldname=ffentry->cFileName;

    strncpy(file->name,oldname,Nsize);
    //copy old filename rut, and do old filename nonsense....

    if (p=strchr(oldname,'.')) {
      if ( (t=p-oldname) < Nsize)
      file->name[t]='\0';
      strncpy(file->ext,p+1,Xsize);
    }
    else file->ext[0]='\0';

    lowern(file->name,Nsize);
    lowern(file->ext,Xsize);

    file->atts=ffentry->dwFileAttributes;
    strncpy(file->lname,ffentry->cFileName,LNAMESIZE);

    if (ffentry->dwFileAttributes & FA_DIREC) {
      file->stat = dstatDIR;

      if (CreationTime) {
        if (!greenwich)
        FileTimeToLocalFileTime(
        &ffentry->ftCreationTime,
        &ffentry->ftCreationTime
        );

        FileTimeToDosDateTime(
        &ffentry->ftCreationTime,&file->date,&file->time);
      }
      else {
        if (!greenwich)
        FileTimeToLocalFileTime(
        &ffentry->ftLastWriteTime,
        &ffentry->ftLastWriteTime
        );

        FileTimeToDosDateTime(
        &ffentry->ftLastWriteTime,&file->date,&file->time);
      }

      if (sum)
      ++dircount;
    }
    else {

//maybe needs FileTimeToLocalFileTime.... // yup that was it.
      if (!greenwich)
      FileTimeToLocalFileTime(
      &ffentry->ftLastWriteTime,
      &ffentry->ftLastWriteTime
      );

      FileTimeToDosDateTime(
      //this gets greenwich time!?! From ol' ntfs u know?
      &ffentry->ftLastWriteTime
      ,&file->date,&file->time);

#if FILE5GIG
      file->size=
      ffentry->nFileSizeLow +
      ((__int64)ffentry->nFileSizeHigh << 32); //?
#else
      file->size=
      ffentry->nFileSizeLow +
      ffentry->nFileSizeHigh * 0x10000; //?
#endif
      file->stat = 0;
      if (sum)
      bytesize += file->size;
    }
  }

  //-----------------------------------------------------
  //the original of this is jgodir95.c:Wshowfililes.

  _f void showfiles(FILE *where, char *mask, int sortstyle) {
    DIRENTRY adir;
    WIN32_FIND_DATA winblk;
    HANDLE wh;

    int idx=0, result, eff;

  #if (!WIN32)
    if (isCc)
    exeunt(19);
  #endif

    dircount=nfiles=0;
    bytesize=0;

    if (!(fnsplit(mask,drive,dir,::file,ext) & (FILENAME|EXTENSION))) {
      fnmerge(newmask,drive,dir,"*",".*");
      mask=newmask;
    }

    trueername(cwd,mask);
    result=fnsplit(cwd,drive,dir,NULL,NULL);
    fnmerge(cwd,drive,dir,NULL,NULL);

  //  lowern(cwd,MaxPath);

  #if 0
    if (! (result & (FILENAME|EXTENSION))) {
      fnmerge(newmask,drive,dir,"*",".*");
      mask=newmask;
    }
  #endif

    bytesize=0;
    wh=FindFirstFile(mask,&winblk);

    dircount=0;

    if (wh==INVALID_HANDLE_VALUE)
    goto WAS_INVALID;

    result = YES;  //just pretend it's a bool...

    while(result) {

  #if ONLY_DIR
      if (
      (onlydirs) &&
      (!(winblk.dwFileAttributes & FA_DIREC))
      )
      goto TRYAGAIN;
  #endif

  #if ExcludeINSHOFILES
      if (
      (!goodatterbutes(winblk.dwFileAttributes)) ||
      ( (winblk.dwFileAttributes & FA_DIREC) && (!includedirs) )
      )
      goto TRYAGAIN;
  #endif

      if (strcmp(winblk.cFileName,".") &&
      strcmp(winblk.cFileName,"..") ) {               /* skip dumb stuff. */

        if (effchars)
        for (eff=0; effchars[eff]; ++eff) {
          if (strichr(winblk.cFileName,effchars[eff]))
          goto TRYAGAIN;
        }

#if TOTALBYTES
        if (!totalbytes)
#endif
        dirintro(HEADIT,where);

        if (!sortstyle) {
          makeafile(&adir,&winblk,YES);
#if TOTALBYTES
          if (!totalbytes)
#endif
          showafilep(where,&adir);
        }
        else {
          makeafile(files+nfiles,&winblk,YES);
        }
        if (sortstyle && (++nfiles > maxfiles)) {
          /* abort to unsorted. */
          for (idx=0; idx<nfiles; ++idx) {
            showafilep(where,files+idx);
          }
          sortstyle=sortNOT;
        }
      }

      TRYAGAIN:
      result=FindNextFile(wh,&winblk);
    }

#if DBG121212
        puts("before findclose\n");
#endif
//    FindClose(&winblk);
// didn't like "jgodir i:\trvl\h2.zip" Wednesday, December 12, 2012 7:27 am.
//just leave it off? Mebbee winders happier that way?

    WAS_INVALID:

#if TOTALBYTES
    if (!totalbytes)
#endif
    if (sortstyle) {
      whosort(sortstyle,nfiles);
      for (idx=0; idx<nfiles; ++idx) {
#if DBG121212
        puts("before showafilep\n");
#endif
        showafilep(where,files+idx);
      }
    }

#if DBG121212
        puts("before dirtrailer\n");
#endif

#if TOTALBYTES
    if (!totalbytes)
#endif

    dirtrailer(where);

#if TOTALBYTES
    totalByteCount += bytesize;
#endif

  }



/****************************************************************************
****************************************************************************/

#else   //WINFindFirst
_f void makeafile(DIRENTRY *file, struct ffblk *ffentry, int sum) {
  int t;
  char *p;

  strncpy(file->name,ffentry->ff_name,Nsize);

  if (p=strchr(ffentry->ff_name,'.')) {
    if ( (t=p-ffentry->ff_name) <Nsize)
    file->name[t]='\0';
    strncpy(file->ext,p+1,Xsize);
  }
  else file->ext[0]='\0';
  lowern(file->name,Nsize);
  lowern(file->ext,Xsize);
  file->atts=ffentry->ff_attrib;
  file->size=ffentry->ff_fsize;
  file->date=ffentry->ff_fdate;
  file->time=ffentry->ff_ftime;

#if WIN32
  strncpy(file->lname,ffentry->ff_name,LNAMESIZE);
#endif

  if (ffentry->ff_attrib & FA_DIREC) {
    file->stat = dstatDIR;
#if WIN32 && (!CREATE_TIME_IMPOSSIBLE)
    if (creationtime) {
      GetCreateTime(file->lname,&file->date,&file->time);
    }
#endif
    if (sum)
    ++dircount;
  }
  else {
    file->stat = 0;
    if (sum)
    bytesize += file->size;
  }
}



/****************************************************************************
the original of this is jgodir95.c:Wshowfililes.
****************************************************************************/

_f void showfiles(FILE *where, char *mask, int sortstyle) {
  DIRENTRY adir;
  struct ffblk ffblk;
  int idx=0, result, eff;

#if (!WIN32)
  if (isCc)
  exeunt(19);
#endif

  dircount=nfiles=0;
  bytesize=0;

  if (!(fnsplit(mask,drive,dir,::file,ext) & (FILENAME|EXTENSION))) {
    fnmerge(newmask,drive,dir,"*",".*");
    mask=newmask;
  }

  trueername(cwd,mask);
  result=fnsplit(cwd,drive,dir,NULL,NULL);
  fnmerge(cwd,drive,dir,NULL,NULL);

//  lowern(cwd,MaxPath);

#if 0
  if (! (result & (FILENAME|EXTENSION))) {
    fnmerge(newmask,drive,dir,"*",".*");
    mask=newmask;
  }
#endif

  bytesize=0;
  result=findfirst(mask,&ffblk,GETSTAT);
  dircount=0;
  while(!result) {

#if (!WIN32)
    if (isCc)
    exeunt(19);
#endif

#if ONLY_DIR
    if (
    (onlydirs) &&
    (!(ffblk.ff_attrib & FA_DIREC))
    )
    goto TRYAGAIN;
#endif

#if ExcludeINSHOFILES
    if (
    (!goodatterbutes(ffblk.ff_attrib)) ||
    ( (ffblk.ff_attrib & FA_DIREC) && (!includedirs) )
    )
    goto TRYAGAIN;
#endif

    if (!(*ffblk.ff_name=='.')) {               /* skip dumb stuff. */

      if (effchars)
      for (eff=0; effchars[eff]; ++eff) {
        if (strichr(ffblk.ff_name,effchars[eff]))
        goto TRYAGAIN;
      }

      dirintro(HEADIT,where);

      if (!sortstyle) {
        makeafile(&adir,&ffblk,YES);
        showafilep(where,&adir);
      }
      else {
        makeafile(files+nfiles,&ffblk,YES);
      }
      if (sortstyle && (++nfiles > maxfiles)) {
        /* abort to unsorted. */
        for (idx=0; idx<nfiles; ++idx) {
          showafilep(where,files+idx);
        }
        sortstyle=sortNOT;
      }
    }

    TRYAGAIN:
    result=findnext(&ffblk);
  }

  findclose(&ffblk);

  if (sortstyle) {
    whosort(sortstyle,nfiles);
    for (idx=0; idx<nfiles; ++idx) {
      showafilep(where,files+idx);
    }
  }

  dirtrailer(where);

}

#endif    //WINFindFirst.

/****************************************************************************
****************************************************************************/

_f char *finddir(struct ffblk *ffblk, int first) {
  if (first) {
    if (findfirst("*.*",ffblk,FA_DIREC))
    return NULL;
  }
  else {
    if (findnext(ffblk)) {
      findclose(ffblk);
      return NULL;
    }
  }
  while ( ! ((ffblk->ff_attrib) & FA_DIREC) ||
  strcmp(ffblk->ff_name,".")==0 ||
  strcmp(ffblk->ff_name,"..")==0) {
    if (findnext(ffblk)) {
      findclose(ffblk);
      return NULL;
    }
  }
  return ffblk->ff_name;  //I hope caller findcloses. ... No we do.
}

_f void directories(FILE *where, char *mask, int sortstyle) {
  char *thisdir, *newdir;
  struct ffblk ffblk;

#if (!WIN32)
  if (isCc)
  exeunt(19);
#endif

  dirintro(LOGCLEAR,NULL);
  dirintro(LOGBUMP,NULL);
  dirintro(LOGHYPHENS,NULL);

  OVshowfiles(where,mask,sortstyle);

  thisdir=OVgetcwd(NULL,MaxPath);

  if (newdir=finddir(&ffblk,YES)) {
    do {
      if (setpath(newdir)) {
        fprintf(errout,"chdir failed. %s defective?\n",newdir);
        /* exeunt(37); */ /* No no keep going. */
      }
      else
      OVdirectories(where,mask,sortstyle);
      setpath(thisdir);
    }
    while(newdir=finddir(&ffblk,NO));
  }
  free(thisdir);
}


/****************************************************************************
****************************************************************************/
#if LFNS
  #define COMPILE " (TC 2.0 w95)"
#else
  #define COMPILE ""
#endif

#if WIN32
  #undef COMPILE
  #define COMPILE " (win32)"

  #define DOSEXE ""

#else

  #define DOSEXE " (Rename to *dos*.exe to defeat W95 processing.)"


#endif



/****************************************************************************

OLD:

        jgodir [mask] [options] Copyright (c) j.g. owen 1994-2012 (`" __DATE__ `")
        i.e., jgodir *.*, or just jgodir.`" COMPILE `" sort by /n name, /s size, /e
        extension (default), /d date & time, /u unsorted. /a show directories
        (default); /a- don't (default for /b /B /c //). /aa only /. Name.dot style. //
        show contents of subdirectories. /w wide. /b[trail] unadorned style, lines
        ended with optional trail. /t 24 hour time. /total just dir byte count.
        /B[trail] == b, + true name. /c[trail] == B, + no drive. -p[prefix] /:a show
        only files with arc attribute. arhs permitted; ORs; unless "/:&ar". Attributes
        in adorned display: a:archive; r:read-only; h:hidden; s:system. Trailing "\"
        taken as directory; else file. (Rename to *dos*.exe to defeat W95 processing.)
        /x no extensions. /q quote bare names. /y summary anyway (bytes) /z- don't
        show free bytes /f~x exclude names with ~, x. -g dir written time.



Put "bare" info back! No DOS.EXE c--p!
NEW:



jgodir [mask] [options] Copyright (c) j.g. owen 1994-2015 (`" __DATE__ `")
i.e., jgodir *.*, or just jgodir. /b bare; /B bare, truename. Sort by /n name,
/s size, /e extension (default), /d date & time, /u unsorted. /a show
directories (default); /a- don't (default for /b /B /c //). /aa only /.
Name.dot style. // show contents of subdirectories. /w wide. /b[trail]
unadorned style, lines ended with optional trail. /t 24 hour time. /total just
dir byte count. /B[trail] == b, + true name. /c[trail] == B, + no drive.
-p[prefix] /:a show only files with arc attribute. arhs permitted; ORs; unless
"/:&ar". Attributes in adorned display: a:archive; r:read-only; h:hidden;
s:system. Trailing "\" taken as directory; else file. /x no extensions. /q
quote bare names. /y summary anyway (bytes) /z- don't show free bytes /f~x
exclude names with ~, x. -g dir written time. /c baredrive?`" COMPILE DOSEXE `"









****************************************************************************/

_f void exeunt(int code) {
  setpath(origwd);
#if (!WIN32)
  removebreak();
#endif
  exit(code);
}

depart() {
  fprintf(errout,





"jgodir [mask] [options] Copyright (c) j.g. owen 1994-2015 (" __DATE__ ")\n"
"i.e., jgodir *.*, or just jgodir. /b bare; /B bare, truename. Sort by /n name,\n"
"/s size, /e extension (default), /d date & time, /u unsorted. /a show\n"
"directories (default); /a- don't (default for /b /B /c //). /aa only /.\n"
"Name.dot style. // show contents of subdirectories. /w wide. /b[trail]\n"
"unadorned style, lines ended with optional trail. /t 24 hour time. /total just\n"
"dir byte count. /B[trail] == b, + true name. /c[trail] == B, + no drive.\n"
"-p[prefix] /:a show only files with arc attribute. arhs permitted; ORs; unless\n"
"\"/:&ar\". Attributes in adorned display: a:archive; r:read-only; h:hidden;\n"
"s:system. Trailing \"\\\" taken as directory; else file. /x no extensions. /q\n"
"quote bare names. /y summary anyway (bytes) /z- don't show free bytes /f~x\n"
"exclude names with ~, x. -g dir written time. /c baredrive?" COMPILE DOSEXE "\n"





  );
  exeunt(1);
}


_f int setdrive(char **mask) {
  int result, c;
  if (**mask && ((*mask)[1]==':')) {
    thedriveletter=**mask;
    c=(*mask)[2];
    (*mask)[2]='\0';
    result=setpath(*mask);
    (*mask)[2]=c;
    *mask += 2;             /* make it path, not drive. */
    return result;
  }
  return 0;
}

#if ONEDIR
_f int itsonedir(char *mask) {
  struct ffblk ffblk;

  if (
  (!(findfirst(mask,&ffblk,0))) ||

  (fnsplit(mask,NULL,NULL,NULL,NULL) & WILDCARDS)) {
    findclose(&ffblk);
    return NO;
  }

  findclose(&ffblk);

  if (!findfirst(mask,&ffblk,FA_DIREC)) {
    findclose(&ffblk);
    return YES;
  }
  return NO;
}

_f int strplus(char *dst, char *src, int max) {
  int index;
  --max;
  index=strlen(dst);
  while(*src && (index < max))
  dst[(index)++]=*src++;
  dst[index]='\0';
  return index;
}

char *slash(char *mask) {
  static char slashpath[MaxPATH+4];
  int i;
  if ( (i=strlen(mask)) && (mask[i-1]!='\\')) {
    strncpy(slashpath,mask,MaxPATH);
    strplus(slashpath,"\\",MaxPATH);
    return strdup(slashpath);
  }
  return
  mask;
}

#endif


_f notminus(char *arg) {
  return arg[2] != '-';
}

#define NOTMINUS() (notminus(argv[i]))

int main(int argc, char *argv[]) {
  int i;
  char *mask=NULL, *p;
#if !WIN32
  long sizeoid;
#endif
  int sortstyle=SortByExt;

#if (!WIN32)
  installbreak();
#endif

#if LFNS
  if (stristr(argv[0],"dos"))
  dosanyway=YES;
#endif

  origwd=OVgetcwd(NULL,MaxPath);
  thedriveletter=getdisk()+'a';

  for (i=1; i<argc; ++i) {
    if (argv[i][0]==opmark) {
      switch (argv[i][1]) {
        case 0: break;
        /* make option alone OK, so he can use files with -. */

        case 'a':
        includedirs=notminus(argv[i]);
#if ONLY_DIR
        if (argv[i][1]=='a')
        onlydirs=YES;
#endif
        break;

        case 'c':
        nobaredrive=NOTMINUS();
/* fall thru to 'B'. */

        case 'B':
        TrueName=NOTMINUS();
#if EXTOP
        noextension=NO;
#endif
/* fall thru to case 'b'. */
        case 'b':
#if BAREWIDE
        boption = NOTMINUS();
#endif
        baretrail=argv[i]+2;
#if !BAREWIDE
        wide=NO;
#endif
        includedirs=NO;

        CASEB:
        bare=NOTMINUS();
        break;

        case '.': dotstyle=NOTMINUS(); break;
        case 'd': sortstyle=SortByDate; break;
        case 'e': sortstyle=SortByExt; break;
        case 'f': effchars = argv[i]+2; break;

#if WINFindFirst
        case 'g': CreationTime = NO; break;
#endif

        case 'n': sortstyle=SortByName; break;
#if PREFIX
        case 'p': prefix=argv[i]+2; break;
#endif

#if QUOTES
        case 'q': quotes=notminus(argv[i]); break;
#endif
        case 's': sortstyle=SortBySize; break;
        case 't':
#if TOTALBYTES
        if (strcmp(argv[i],"/total"))
        military=NOTMINUS();
        else {
          totalbytes = YES;
        }
#else
        military=NOTMINUS();
#endif
        break;

        case 'u': sortstyle=sortNOT; break;
        case 'w': wide=NOTMINUS(); goto CASEB;

#if EXTOP
        case 'x': noextension=NOTMINUS(); TrueName=NO; break;
#endif

        case 'y': trailer_anyway = NOTMINUS(); break;

        case 'z': bytes_left = NOTMINUS(); break;

        case '/':
        subs=NOTMINUS();
        includedirs=NO;
        diranyway=NO;
        break;

        case ':':
        attract=ATTOR;
        attributes=0;
        p=argv[i]+2;
        while(*p) {
          switch(*p) {
            case '&': attract=ATTAND; break;
            case 'a': attributes|=FA_ARCH; break;
            case 'r': attributes|=FA_RDONLY; break;
            case 's': attributes|=FA_SYSTEM; break;
            case 'h': attributes|=FA_HIDDEN; break;
            default:
            depart();
          }
          ++p;
        }
        break;

        default:
        depart();
      }
    }
    else if (!mask)
    mask=argv[i];
    else depart();
  }


#if WIN32
  if (!mask)
  mask = "*";
#else
  if (!mask) {
#if LFNS
    if (win95())
    mask="*";
    else
#endif
    mask="*.*";
  }
#endif

  if (setdrive(&mask)) {
    fprintf(errout,"Couldn't change drives.");
    exeunt(1);
  }

#if WIN32
#ifdef BIGMAX
    maxfiles = BIGMAX;
#else
    maxfiles = 5000;
#endif

    if (!(files=(DIRENTRY*)malloc( (maxfiles+1) * sizeof(DIRENTRY)))) {
      fprintf(errout,"Couldn't malloc().");
      exeunt(7);
    }

#else   // WIN32

    if ( (sizeoid=((coreleft()/5L)*4L))>0xFFFFL)
    sizeoid=0xFFFFL;

    if (!(files=(DIRENTRY*)malloc(sizeoid))) {
      fprintf(errout,"Couldn't malloc().");
      exeunt(7);
    }

    maxfiles=sizeoid/sizeof(DIRENTRY)-1;

#endif

  if (subs) {
    char newpath[MaxPath], drive[MAXDRIVE], dir[MAXDIR], file[MAXFILE],
    ext[MAXEXT], newmask[MaxPATH];

    hycount=0;

#if DBG030515_OK
    printf("MaxPath,MaxPATH,MAXPATH:%d,%d,%d, MAXDRIVE:%d, MAXDIR:%d, \n"
           "MAXFILE:%d, MAXEXT:%d\n",
           MaxPath,MaxPATH,MAXPATH,
           MAXDRIVE,MAXDIR,
           MAXFILE, MAXEXT);
#endif

    if (itsonedir(mask))
    mask = slash(mask);

    if (slashed(mask)) {
      fnmerge(newmask,NULL,NULL,"*",".*");
      if (setpath(mask)) {
        fprintf(errout,"chdir (%s) failed.\n",mask);
        exeunt(38);
      }
    }
    else {
      fnsplit(mask,drive,dir,file,ext);
      fnmerge(newpath,drive,dir,NULL,NULL);
      fnmerge(newmask,NULL,NULL,file,ext);
      slashed(newpath);
      if (setpath(newpath)) {
        fprintf(errout,"chdir (%s) failed.\n",newpath);
        exeunt(38);
      }
    }
    OVdirectories(stdout,newmask,sortstyle);
  }
  else {
#if ONEDIR
    if (itsonedir(mask))
    mask=slash(mask);
#endif

    dirintro(LOGCLEAR,NULL);
    dirintro(LOGBUMP,NULL);
    OVshowfiles(stdout,mask,sortstyle);

  }

#if TOTALBYTES
  if (!totalbytes)
  fputc('\n',stdout);
//it should always no?
  fprintf(stdout,"total byte count: %s\n",commad(totalByteCount,500));

#endif

  exeunt(0);

}


