/* jgodir.h   Tue 04-16-1996
Tue 04-16-1996  creation from JGODIR.C.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <alloc.h>
#include <io.h>
#include <fcntl.h>

#define YES (1)
#define NO (0)

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */

#if __FLAT__
  #define WIN32 YES
  #include <windows.h>
#else
  #define WIN32 NO
#endif

#ifndef BYTE
  #define BYTE char
#endif

#ifndef sBYTE
  #define sBYTE signed char
#endif

#ifndef BIG
  typedef unsigned long BIG;
#endif

#define ARRAYSIZE(x) (sizeof(x) / sizeof(x[0]))

#define ENTER (13)
#define CR (13)
#define LF (10)
#define CTL (0x40)        /* 'A'-CTL is ^A. */
#define ESC (0x1b)
#define DEL (0x5300)
#define BS (8)
#define TAB (9)

#define BIT0 (1)
#define BIT1 (2)
#define BIT2 (4)
#define BIT3 (8)
#define BIT4 (16)
#define BIT5 (32)
#define BIT6 (64)
#define BIT7 (128)
#define BIT8 (256)
#define BIT9 (512)
#define BIT10 (1024)
#define BIT11 (2048)
#define BIT12 (4096)
#define BIT13 (8192)
#define BIT14 (16384)
#define BIT15 (32768)
#define BIT16 (65536)
#define BIT17 (131072)
#define BIT18 (262144)
#define BIT19 (524288)
#define BIT20 (1048576)
#define BIT21 (2097152)
#define BIT22 (4194304)
#define BIT23 (8388608)
#define BIT24 (16777216)
#define BIT25 (33554432)
#define BIT26 (67108864)
#define BIT27 (134217728)
#define BIT28 (268435456)
#define BIT29 (536870912)
#define BIT30 (1073741824)
#define BIT31 (2147483648)

#define nBIT(x) (1 << x)                          /*  */
#define lo(one,two) ( ((one) < (two)) ? (one) : (two))    /*  */
#define hi(one,two) ( ((one) > (two)) ? (one) : (two))    /* not tested. */

#define LOW(x) ((x) & 255)
#define HIGH(x) ((x) >> 8)

#define LOCALK enum       /* that's what I learned in c--. LOCALK { bingo=1 }
                          etc. */

#define ONEDIR YES

#define FILE5GIG YES      /* sad times are upon us in Tue 2/17/15 1:47 pm. So
it turned-out to be all __int64  which I *knew* about apparently, but not
enough. But then I never saw a 5 gigabyte file before. Then there was one I
was copying from hp8gig to acer2,
c:\tempjgo\3584_CorelX4\iso\3584named3583.iso which JGODIR, JCOPY, and
OWENSHOW saw wrong, but DIR of course saw right. See __int64, particularly
functions droom and commad. */

void exeunt(int code);

/* used to be ((x)&15) */
#define AD1(x) (toupper(x)-'@')    /* alpha-drive, 1-based. */

/****************************************************************************
****************************************************************************/
#ifdef __TURBOC__ /* I'm almost certain this is DOS but whatever. */
/* for ffblk-style time, date. */
typedef union {
  WORD time;
  struct {
    WORD
    seconds:5,
    minutes:6,
    hours:5;
  } bits;
} FFTIME;

typedef union {
  WORD date;
  struct {
    WORD
    date:5,
    month:4,
    year80:7;
  } bits;
} FFDATE;

#define SECONDS(x) ( ((FFTIME*) &x)->bits.seconds)
#define MINUTES(x) ( ((FFTIME*) &x)->bits.minutes)
#define HOURS(x) ( ((FFTIME*) &x)->bits.hours)

#define DATE(x)   ( ((FFDATE*) &x)->bits.date)
#define MONTH(x)   ( ((FFDATE*) &x)->bits.month)
#define YEAR80(x)   ( ((FFDATE*) &x)->bits.year80)
#define YEAR(x)   ((( ((FFDATE*) &x)->bits.year80)+80)%100)
#endif


/****************************************************************************
****************************************************************************/
#define FIXWIN95 YES
#define SHOWDIRATTS FIXWIN95

#if FIXWIN95
  #define JGO_OK BIT15
#else
  #define findfirstdos    findfirst
  #define findnextdos     findnext
#endif



#define LFNS (YES && (defined(__LARGE__)))
/* the long file name catastrophe. */

#if LFNS

  #if ( (!defined(__LARGE__)) || (!FIXWIN95) )
    #error Gotta be *LARGE* LFNS, + FIXWIN95 (?)
  #endif

  #define MAX95PATH (280)

  #define MaxPATH MAX95PATH

  typedef struct {
    WORD
    time, date;
  } OLDDOSTIME;

  typedef union {
    BIG LowDateTime;
    OLDDOSTIME dos;
  } LOWDATETIME;

  typedef struct {
    LOWDATETIME Low;
    BIG High;
  } FILETIME;

  #define NAMESIZE95 (260)   /* should be <= MAX95PATH but is exact. */
  /* undocumented. That's what it looked like. */

  typedef struct {
    BIG FileAttributes;
    FILETIME ftCreationTime;
    FILETIME ftLastAccessTime;
    FILETIME ftLastWriteTime;
    BIG nFilesSizeHigh;
    BIG nFileSizeLow;
    BIG r1, r2;
    char cFileName[NAMESIZE95];
    char cAlternateFileName[14];

  /* additional stupid data not included by DOS. */
    int handle, unicode;

  } FBLOCK95;

  /* must do prototype here, because when I #define OV_chmod as _chmod below,
  it conflicts with the stupid "..." form of the real _chmod. */
  int OV_chmod(const char *path, int func, int attrib);

#ifdef __FLAT__

  #undef MaxPATH
  #define MaxPATH MAXPATH

#else

  #undef  MAXPATH
  #undef  MAXDIR
  #undef  MAXFILE
  #undef  MAXEXT
  #undef  MAX95PATH

  #define MAXPATH (MAX95PATH)
  #define MAXDIR  (MAX95PATH)
  #define MAXFILE (NAMESIZE95)
  #define MAXEXT  (NAMESIZE95)
  #deinfe MAX95PATH MAXPATH

#endif

/* but note that ovmerge and ovsplit must be linked. */
  #define OVfopen     fopen
  /* see OVOPEN etc. */

enum {
  WIN95RUNNING=1,
  JUSTDOS7
};



#else

  typedef struct {
    int for_prototypes;
  } FBLOCK95;

  #define MaxPATH MAXPATH
  #define OVchdir     chdir
  #define OVgetcwd    getcwd
  #define OVrename    rename
  #define OV_chmod    _chmod
  #define OVunlink    unlink
  #define OVfopen     fopen
  #define OVmkdir     mkdir
  #define OVrmdir     rmdir
  #define OV_open     _open
  #define OVdirectories directories
  #define OVshowfiles showfiles
  #define OVtruename truename
#endif

/****************************************************************************
****************************************************************************/
/*
ABCDF    BAK      499   03-09-92 12:20a   A
                        1234567890123456
12345678.BOI 10,123,123 03-09-92 12:20a ARH
*/

#define WINFindFirst YES    //try and get that *()&()*& creation time.

#define Nsize (8)
#define Xsize (3)
#define LNAMESIZE (256)

typedef struct {
  char name[Nsize], ext[Xsize];
#if LFNS || WIN32
  char lname[LNAMESIZE], *lext;
  char ksize[5];      /* i.e. "123K" "2G" etc. */
  WORD llength;
#endif
  BYTE stat;
  #define dstatMARKED BIT0    /* +. */
  #define dstatDONE   BIT1    /* *. */
  #define dstatDIR    BIT2
  #define dstatMORE   BIT3    /* the more entry. */
  #define dstatDEL    BIT4    /* remove from table. */
  BYTE atts;
#if FILE5GIG
//  int64 size;     /*that'ull learn 'em. 2/15/15. //didn't*/
  __int64 size;
#else
  long size;
#endif
#if WINFindFirst
  unsigned short time, date;  //to fit FileTimeToDosDateTime().
#else
  unsigned int time, date;
#endif
} DIRENTRY;

/****************************************************************************
****************************************************************************/
#if WIN32
  #define MaxPath MAXPATH
#else
  #if MaxPATH<129
    #define MaxPath 129
  #else
    #define MaxPath MaxPATH
  #endif
#endif

enum {
  LOGBUMP,
  LOGHYPHENS,
  LOGCLEAR,
  HEADIT,
  HEADITANYWAY
};

#define WIDELINE (65)
#define WIDEFIELD (16)

#define GETSTAT (FA_HIDDEN|FA_SYSTEM|FA_DIREC)

#define GIGAK NO
#define opmark '/'

enum {
  sortNOT=0,
  SortByName,
  SortByExt,
  SortBySize,
  SortByDate
};

#define ExcludeINSHOFILES YES     /* perilously rearrange the logic. */

#define EXTOP YES           /* provide way of showing files sans extensions */

#define BAREWIDE YES        /* for some reason I had wide defeat some bare. */

#define NETDIR0 YES /* try to see directories better; failure on net drive. */

#define DOTCRASH YES    /* "Wtruename(dst,".") crashes on ML at
"trueername(cwd,".") in jgodir95.c. So we just won't do that. */

#define ONLY_DIR YES    /* allow option to JUST show dirs */

#define PREFIX YES      /* like baretrail. */

#define QUOTES YES      /* make 'em quote bare file names. */

#define DBG121212 NO /*YES   /* crash only outside of ide of course. */

#define TOTALBYTES YES  /* Just byte counts, for optional multiple dirs. */

#define DBG030515 YES

/****************************************************************************
****************************************************************************/

#include "jgodir.p"
